process equationSolving_TRA =
     ( ? real a, b, c;
       ! real x2, x1;
         boolean error;
     )
   pragmas 
      Main
   end pragmas
   (| (| CLK_stable := ^CLK_stable
       | ACT_CLK_stable{}
       |) |)
   where 
   constant real cst_epsilon = 0.00001;
   event CLK_stable;
   process ACT_CLK_stable =
        ( )
      (| CLK_stable ^= stable ^= yy ^= next_yy ^= biterate ^= mx ^= pre_next_yy ^= next_stable ^= s ^= XZX_166
       | (| CLK_66 := when biterate
          | CLK_67 := when (not biterate)
          |)
       | (| CLK_83 := when (XZX_166>=0.0)
          | CLK_84 := when (not (XZX_166>=0.0))
          |)
       | (| CLK_x2 := when (next_stable and biterate)
          | CLK_x2 ^= x2 ^= x_198
          | ACT_CLK_x2{}
          | CLK_91 := when (not (next_stable and biterate))
          |)
       | (| XZX_216 := when stable
          | XZX_216 ^= a ^= b ^= c
          | ACT_XZX_216{}
          | CLK_121 := when (not stable)
          |)
       | (| CLK_200 := CLK_x2 ^+ XZX_216 |)
       | (| CLK_XZX_185 := CLK_x2 ^+ XZX
          | CLK_XZX_185 ^= XZX_185
          | (| XZX_185 := (bb when XZX) cell CLK_XZX_185 init 0.0e0 |)
          |)
       | (| CLK_x21 := CLK_x2 ^+ nul_61
          | CLK_x21 ^= x21
          | (| x21 := (x_198 when CLK_x2) default (x_100 when CLK_224) |)
          |)
       | (| CLK_208 := CLK_x21 ^+ err_1_24 |)
       | (| CLK_x1 := CLK_x21 ^+ CLK_x
          | CLK_x1 ^= x1
          | (| x1 := (x21 when CLK_x21) default (x when CLK_226) |)
          |)
       | (| CLK_212 := CLK_x1 ^+ CLK_error |)
       | (| CLK_221 := CLK_stable ^- CLK_d |)
       | (| CLK_224 := nul_61 ^- CLK_x2 |)
       | (| CLK_226 := CLK_x ^- CLK_x21 |)
       | (| stable := next_stable$1 init true
          | yy := ((d/2.0) when CLK_d) default (pre_next_yy when CLK_221)
          | next_yy := (((yy+(mx/yy))/2.0) when CLK_66) default (yy when CLK_67)
          | biterate := CLK_d default ((not stable) when CLK_221)
          | mx := (d when CLK_d) cell CLK_stable init 0.0e0
          | pre_next_yy := next_yy$1 init 1.0
          | next_stable := s<cst_epsilon
          | s := (XZX_166 when CLK_83) default ((-XZX_166) when CLK_84)
          | XZX_166 := next_yy-yy
          |)
       |)
      where 
      event CLK_226, CLK_224, CLK_221, CLK_212, CLK_x1, CLK_208, CLK_error, CLK_x21, CLK_XZX_185, CLK_200, CLK_x, CLK_121, XZX_216, CLK_91, CLK_x2, CLK_84, CLK_83, CLK_67, CLK_66, err_1_24, nul_61, CLK_d, XZX;
      boolean stable, biterate, next_stable;
      real x, d, bb, x_100, yy, next_yy, mx, pre_next_yy, s, XZX_166, XZX_185, x_198, x21;
      process ACT_CLK_x2 =
           ( )
         (| CLK_x2 ^= y ^= bb_126 ^= x_189
          | (| x2 := x_189
             | y := yy when CLK_x2
             | bb_126 := XZX_185 when CLK_x2
             | x_189 := -((bb_126-y)/2.0)
             | x_198 := -((bb_126+y)/2.0)
             |)
          |)
         where 
         real y, bb_126, x_189;
         end
      %ACT_CLK_x2%; 
      process ACT_XZX_216 =
           ( )
         (| XZX_216 ^= OK
          | (| XZX := when OK
             | XZX ^= bb
             | ACT_XZX{}
             | XZX_223 := when (not OK)
             | ACT_XZX_223{}
             |)
          | (| CLK_error := err_1_24 ^+ CLK_err2
             | CLK_error ^= error
             | ACT_CLK_error{}
             |)
          | (| OK := a/=0.0 |)
          |)
         where 
         event CLK_err2, XZX_223;
         boolean OK, err2;
         process ACT_XZX =
              ( )
            (| XZX ^= cc ^= dd ^= aa ^= XZX_92 ^= XZX_96
             | (| CLK_d := when (dd>0.0)
                | CLK_d ^= d
                | (| d := dd when CLK_d |)
                | CLK := when (not (dd>0.0))
                |)
             | (| nul_61 := when (dd=0.0)
                | nul_61 ^= x_100
                | ACT_nul_61{}
                | CLK_30 := when (not (dd=0.0))
                |)
             | (| err_1_24 := when (dd<0.0)
                | CLK_32 := when (not (dd<0.0))
                |)
             | (| CLK_193 := nul_61 ^+ err_1_24 |)
             | (| CLK_195 := CLK_d ^+ CLK_193 |)
             | (| CLK_197 := CLK_d ^+ err_1_24 |)
             | (| bb := XZX_92/aa
                | cc := XZX_96/aa
                | dd := (bb*bb)-(4.0*cc)
                | aa := a when XZX
                | XZX_92 := b when XZX
                | XZX_96 := c when XZX
                |)
             |)
            where 
            event CLK_197, CLK_195, CLK_193, CLK_32, CLK_30, CLK;
            real cc, dd, aa, XZX_92, XZX_96;
            process ACT_nul_61 =
                 ( )
               (| nul_61 ^= XZX_103
                | (| x_100 := (-XZX_103)/2.0
                   | XZX_103 := bb when nul_61
                   |)
                |)
               where 
               real XZX_103;
               end
            %ACT_nul_61%; 
            end
         %ACT_XZX%; 
         process ACT_XZX_223 =
              ( )
            (| XZX_223 ^= bb_254 ^= cc_255
             | (| CLK_x := when (bb_254/=0.0)
                | CLK_x ^= x
                | ACT_CLK_x{}
                | CLK_139 := when (not (bb_254/=0.0))
                |)
             | (| CLK_err2 := when (bb_254=0.0)
                | CLK_err2 ^= err2
                | (| err2 := (cc_255/=0.0) when CLK_err2 |)
                | CLK_151 := when (not (bb_254=0.0))
                |)
             | (| CLK_191 := CLK_x ^+ CLK_err2 |)
             | (| bb_254 := b when XZX_223
                | cc_255 := c when XZX_223
                |)
             |)
            where 
            event CLK_191, CLK_151, CLK_139;
            real bb_254, cc_255;
            process ACT_CLK_x =
                 ( )
               (| CLK_x ^= bb_237 ^= cc_238
                | (| x := -(cc_238/bb_237)
                   | bb_237 := bb_254 when CLK_x
                   | cc_238 := cc_255 when CLK_x
                   |)
                |)
               where 
               real bb_237, cc_238;
               end
            %ACT_CLK_x%; 
            end
         %ACT_XZX_223%; 
         process ACT_CLK_error =
              ( )
            (| CLK_error ^= err_260
             | (| error := err_260
                | err_260 := err_1_24 default (err2 when CLK_err2)
                |)
             |)
            where 
            boolean err_260;
            end
         %ACT_CLK_error%; 
         end
      %ACT_XZX_216%; 
      end
   %ACT_CLK_stable%; 
   end
%equationSolving_TRA%; 
