process archi =
     ( ? real c;
         real b;
         real a;
       ! boolean error;
         real x1;
         real x2;
     )
   (| (| PROC1{}
       | PROC2{}
       |)/ err2, x, OK |)
   where 
   process PROC1 =
        ( ? real a;
            real b;
            real c;
            real x;
            err2;
          ! boolean OK;
            real x2;
            x1;
            boolean error;
        )
      pragmas 
         RunOn "1"
      end pragmas
      (| (| (| err1 := err
             | a1 := x21
             | a2 := x
             | (| x1 := a1 default a2
                | error := err1 default err2
                |)
             |) where real a2, a1;
                      event err1; end
          | SecondDegree{0.0001}(when OK,a,b,c)
          | OK := a/=0.0
          |)/ err, x21 |)
      where 
      real x21;
      event err;
      end
   ; 
   process PROC2 =
        ( ? boolean OK;
            real b;
            real c;
            real a;
          ! real x;
            err2;
        )
      pragmas 
         RunOn "2"
      end pragmas
      (| (| a ^= b ^= c
          | FirstDegree(when (not OK),b,c)
          |) |)
   ; 
   process SecondDegree =
        { real epsilon; }
        ( ? event OK;
            real a;
            real b;
            real c;
          ! event err;
            real x21;
            real x2;
        )
      (| (| (| c := cc
             | b := bb
             | Discriminant{}
             |) where real b, c; end
          | (| aa := a when OK
             | bb := (b when OK)/aa
             | cc := (c when OK)/aa
             | c ^= b ^= a
             |)/ aa
          | (| b := bb
             | x0 := (-(b when nul))/2.0
             |) where real b; end
          | (| b := bb
             | discr := d
             | DeuxRacines{epsilon}
             |) where real discr, b; end
          | x21 := x1 default x0
          | (| x := c
             | x ^= when stable
             |) where real x; end
          |)/ stable, x1, x0, cc, bb, d, nul |)
      where 
      process Discriminant =
           ( ? real b;
               real c;
             ! event nul;
               event err;
               real d;
           )
         (| dd := (b*b)-(4.0*c)
          | d := dd when (dd>0.0)
          | nul := when (dd=0.0)
          | err := when (dd<0.0)
          |)
         where 
         real dd;
         end
      ; 
      process DeuxRacines =
           { real eps; }
           ( ? real discr;
               real b;
             ! boolean stable;
               real x1;
               real x2;
           )
         (| (| rac{eps}(discr)
             | (| d := y
                | bb := (b cell (^d)) when (^d)
                |) where real d; end
             | (| b := bb
                | d := y
                | x := -((b-d)/2.0)
                | x2 := x
                |) where real x, d;
                         b; end
             | (| b := bb
                | d := y
                | x := -((b+d)/2.0)
                | x1 := x
                |) where real x, d;
                         b; end
             |)/ bb, y |)
         where 
         process rac =
              { real epsilon; }
              ( ? real x;
                ! boolean stable;
                  real y;
              )
            (| (| (| mx := x cell (^yy)
                   | next_yy := (((yy+(mx/yy))/2.0) when biterate) default yy
                   | yy := (x/2.0) default (next_yy$1 init 1.0)
                   |)/ mx
                | (| biterate := (^x) default (not stable)
                   | next_stable := abs(next_yy-yy)<epsilon
                   | stable := next_stable$1 init true
                   | yy ^= stable
                   | y := yy when (next_stable and biterate)
                   |)/ next_stable
                |)/ biterate, next_yy, yy |)
            where 
            process abs =
                 ( ? x;
                   ! s;
                 )
               (| s := (x when (x>=0.0)) default (-x) |)
            ; 
            real yy, next_yy, mx;
            boolean next_stable, biterate;
            end
         ; 
         real y;
         bb;
         end
      ; 
      event nul;
      real d, bb, aa, cc, x0;
      x1, stable;
      end
   ; 
   process FirstDegree =
        ( ? boolean Compute;
            real b;
            real c;
          ! real x;
            boolean err2;
        )
      (| (| (| (| c := cc_2
                | b := bb_1
                | (| bb := b when (b/=0.0)
                   | cc := c when (b/=0.0)
                   | x := -(cc/bb)
                   |)
                |)/ cc, bb |) where real b, c; end
          | (| c := cc_2
             | b := bb_1
             | error := (c/=0.0) when (b=0.0)
             | err2 := error
             |) where boolean error;
                      real b, c; end
          | (| (| bb := b when Compute
                | cc := c when Compute
                |)
             | bb_1 := bb
             | cc_2 := cc
             |) where real bb, cc; end
          |)/ cc_2, bb_1 |)
      where 
      real bb, cc, bb_1, cc_2;
      end
   ; 
   boolean OK;
   real x;
   err2;
   end
; 
