process equationSolving_archi_TRA =
     ( ? real a, b, c;
       ! real x2, x1;
         boolean error;
     )
   pragmas 
      main ""
   end pragmas
   (| (| CLK_stable := ^CLK_stable
       | ACT_CLK_stable{}
       |) |)
   where 
   constant real cst_epsilon = 0.0001;
   constant real epsilon = 0.0001;
   event CLK_stable;
   process ACT_CLK_stable =
        ( )
      (| CLK_stable ^= stable ^= yy ^= next_yy ^= biterate ^= mx ^= XZX_130 ^= next_stable ^= s ^= x_143
       | (| CLK_56 := when biterate
          | CLK_57 := when (not biterate)
          |)
       | (| CLK_73 := when (x_143>=0.0)
          | CLK_74 := when (not (x_143>=0.0))
          |)
       | (| CLK_x2 := when (next_stable and biterate)
          | CLK_x2 ^= x2 ^= x_173
          | ACT_CLK_x2{}
          | CLK_81 := when (not (next_stable and biterate))
          |)
       | (| CLK_a := when stable
          | CLK_a ^= a ^= b ^= c
          | ACT_CLK_a{}
          | CLK_109 := when (not stable)
          |)
       | (| CLK_179 := CLK_x2 ^+ CLK_a |)
       | (| CLK_XZX_160 := CLK_x2 ^+ CLK_bb
          | CLK_XZX_160 ^= XZX_160
          | XZX_160 := (bb when CLK_bb) cell CLK_XZX_160 init 0.0e0
          |)
       | (| CLK_x21 := CLK_x2 ^+ CLK_x0
          | CLK_x21 ^= x21
          | x21 := (x_173 when CLK_x2) default (x0 when CLK_200)
          |)
       | (| CLK_x1 := CLK_x21 ^+ CLK_x
          | CLK_x1 ^= x1
          | x1 := (x21 when CLK_x21) default (x when CLK_202)
          |)
       | (| CLK_189 := CLK_x1 ^+ CLK_error |)
       | (| CLK_197 := CLK_stable ^- CLK_d |)
       | (| CLK_200 := CLK_x0 ^- CLK_x2 |)
       | (| CLK_202 := CLK_x ^- CLK_x21 |)
       | (| stable := next_stable$1 init true
          | yy := ((d/2.0) when CLK_d) default (XZX_130 when CLK_197)
          | next_yy := (((yy+(mx/yy))/2.0) when CLK_56) default (yy when CLK_57)
          | biterate := CLK_d default ((not stable) when CLK_197)
          | mx := (d when CLK_d) cell CLK_stable init 0.0e0
          | XZX_130 := next_yy$1 init 1.0
          | next_stable := s<epsilon
          | s := (x_143 when CLK_73) default ((-x_143) when CLK_74)
          | x_143 := next_yy-yy
          |)
       |)
      where 
      event CLK_202, CLK_200, CLK_197, CLK_189, CLK_x1, CLK_error, CLK_x21, CLK_XZX_160, CLK_179, CLK_x, CLK_109, CLK_a, CLK_81, CLK_x2, CLK_74, CLK_73, CLK_57, CLK_56, CLK_x0, CLK_d, CLK_bb;
      real x, x21, bb, d, x0;
      boolean stable;
      real yy, next_yy;
      boolean biterate;
      real mx, XZX_130;
      boolean next_stable;
      real s, x_143, XZX_160, x_173;
      process ACT_CLK_x2 =
           ( )
         (| CLK_x2 ^= y ^= bb_106 ^= x_164
          | (| x2 := x_164
             | y := yy when CLK_x2
             | bb_106 := XZX_160 when CLK_x2
             | x_164 := -((bb_106-y)/2.0)
             | x_173 := -((bb_106+y)/2.0)
             |)
          |)
         where 
         real y, bb_106, x_164;
         end
      %ACT_CLK_x2%; 
      process ACT_CLK_a =
           ( )
         (| CLK_a ^= OK
          | (| CLK_bb := when OK
             | CLK_bb ^= bb
             | ACT_CLK_bb{}
             | CLK_bb_220 := when (not OK)
             | ACT_CLK_bb_220{}
             |)
          | (| CLK_error := CLK_27 ^+ CLK_error_215
             | CLK_error ^= error
             | error := CLK_27 default (error_215 when CLK_error_215)
             |)
          | (| OK := a/=0.0 |)
          |)
         where 
         event CLK_error_215, CLK_27, CLK_bb_220;
         boolean OK, error_215;
         process ACT_CLK_bb =
              ( )
            (| CLK_bb ^= cc ^= dd ^= aa ^= XZX ^= XZX_82
             | (| CLK_d := when (dd>0.0)
                | CLK_d ^= d
                | d := dd when CLK_d
                | CLK := when (not (dd>0.0))
                |)
             | (| CLK_x0 := when (dd=0.0)
                | CLK_x0 ^= x0
                | ACT_CLK_x0{}
                | CLK_26 := when (not (dd=0.0))
                |)
             | (| CLK_27 := when (dd<0.0)
                | CLK_28 := when (not (dd<0.0))
                |)
             | (| CLK_175 := CLK_x0 ^+ CLK_27 |)
             | (| CLK_177 := CLK_d ^+ CLK_175 |)
             | (| bb := XZX/aa
                | cc := XZX_82/aa
                | dd := (bb*bb)-(4.0*cc)
                | aa := a when CLK_bb
                | XZX := b when CLK_bb
                | XZX_82 := c when CLK_bb
                |)
             |)
            where 
            event CLK_177, CLK_175, CLK_28, CLK_26, CLK;
            real cc, dd, aa, XZX, XZX_82;
            process ACT_CLK_x0 =
                 ( )
               (| CLK_x0 ^= XZX_88
                | (| x0 := (-XZX_88)/2.0
                   | XZX_88 := bb when CLK_x0
                   |)
                |)
               where 
               real XZX_88;
               end
            %ACT_CLK_x0%; 
            end
         %ACT_CLK_bb%; 
         process ACT_CLK_bb_220 =
              ( )
            (| CLK_bb_220 ^= bb_220 ^= cc_221
             | (| CLK_x := when (bb_220/=0.0)
                | CLK_x ^= x
                | ACT_CLK_x{}
                | CLK_124 := when (not (bb_220/=0.0))
                |)
             | (| CLK_error_215 := when (bb_220=0.0)
                | CLK_error_215 ^= error_215
                | error_215 := (cc_221/=0.0) when CLK_error_215
                | CLK_136 := when (not (bb_220=0.0))
                |)
             | (| bb_220 := b when CLK_bb_220
                | cc_221 := c when CLK_bb_220
                |)
             |)
            where 
            event CLK_136, CLK_124;
            real bb_220, cc_221;
            process ACT_CLK_x =
                 ( )
               (| CLK_x ^= bb_203 ^= cc_204
                | (| x := -(cc_204/bb_203)
                   | bb_203 := bb_220 when CLK_x
                   | cc_204 := cc_221 when CLK_x
                   |)
                |)
               where 
               real bb_203, cc_204;
               end
            %ACT_CLK_x%; 
            end
         %ACT_CLK_bb_220%; 
         end
      %ACT_CLK_a%; 
      end
   %ACT_CLK_stable%; 
   end
%equationSolving_archi_TRA%; 
