process equationSolving_TRA =
     ( ? real a, b, c;
       ! real x2, x1;
         boolean error;
     )
   pragmas 
      main
   end pragmas
   (| (| CLK_C_x := ^CLK_C_x
       | ACT_CLK_C_x{}
       |)
    | (| {c --> err} when CLK_err
       | {c --> x21} when CLK_182
       | {c --> x2} when CLK_172
       | {b --> err} when CLK_err
       | {b --> x21} when CLK_182
       | {b --> x2} when CLK_172
       | {a --> err} when CLK_err
       | {a --> x21} when CLK_182
       | {a --> x2} when CLK_172
       |)
    |)
   where 
   constant real cst_epsilon = 0.0001;
   event CLK_C_x;
   process ACT_CLK_C_x =
        ( )
      (| CLK_C_x ^= C_x ^= stable ^= C_y
       | (| CLK_a := when stable
          | CLK_a ^= a ^= b ^= c ^= C_bb
          | ACT_CLK_a{}
          | CLK := when (not stable)
          |)
       | (| CLK_x2 := when C_y
          | CLK_x2 ^= x2
          | CLK_86 := when (not C_y)
          |)
       | (| CLK_x21 := when C_x
          | CLK_x21 ^= x21
          | CLK_95 := when (not C_x)
          |)
       | (| CLK_172 := CLK_a ^* CLK_x2 |)
       | (| CLK_174 := CLK_x2 ^+ CLK_err |)
       | (| CLK_176 := CLK_x21 ^+ CLK_174 |)
       | (| CLK_178 := CLK_x21 ^+ CLK_err |)
       | (| CLK_180 := CLK_x21 ^+ CLK_C_err |)
       | (| CLK_182 := CLK_a ^* CLK_x21 |)
       | (| CLK_184 := CLK_180 ^+ CLK_x2 |)
       | (| CLK_187 := CLK_176 ^+ CLK_a |)
       | (| CLK_193 := CLK_x21 ^+ CLK_191 |)
       | (| CLK_195 := CLK_193 ^+ CLK_err |)
       | (| CLK_197 := CLK_195 ^+ CLK_bb_1 |)
       | (| CLK_199 := CLK_195 ^+ CLK_a |)
       | (| CLK_x1 := CLK_x21 ^+ CLK_x
          | CLK_x1 ^= x1
          | ACT_CLK_x1{}
          |)
       | (| CLK_206 := CLK_x ^- CLK_x21 |)
       | (| (err,x21,x2,stable,C_y,C_bb,C_err,C_x) := SecondDegree_ABS(a,b,c) |)
       |)
      where 
      event CLK_206, CLK_x1, CLK_199, CLK_197, CLK_195, CLK_193, CLK_191, CLK_187, CLK_184, CLK_182, CLK_180, CLK_178, CLK_176, CLK_174, CLK_172, CLK_bb_1, CLK_x, CLK_95, CLK_x21, CLK_err, CLK_C_err, CLK_86, CLK_x2, CLK, CLK_a;
      boolean err, C_x, C_bb, C_err, stable, C_y;
      real x, x21;
      process ACT_CLK_a =
           ( )
         (| CLK_a ^= OK ^= XZX_126
          | (| CLK_C_err := when C_bb
             | CLK_C_err ^= C_err
             | ACT_CLK_C_err{}
             | CLK_89 := when (not C_bb)
             |)
          | (| CLK_bb_1 := when XZX_126
             | ACT_CLK_bb_1{}
             | CLK_130 := when (not XZX_126)
             |)
          | (| CLK_error := CLK_err2 ^+ CLK_145
             | CLK_error ^= error
             | (| error := CLK_145 default (err2 when CLK_208) |)
             |)
          | (| CLK_191 := CLK_error ^+ CLK_x |)
          | (| CLK_208 := CLK_err2 ^- CLK_145 |)
          | (| OK := a/=0.0
             | XZX_126 := not OK
             |)
          |)
         where 
         event CLK_208, CLK_error, CLK_145, CLK_130, CLK_err2, CLK_89;
         boolean OK, XZX_126, err2;
         process ACT_CLK_C_err =
              ( )
            (| (| CLK_err := when C_err
                | CLK_err ^= err
                | ACT_CLK_err{}
                | CLK_92 := when (not C_err)
                |) |)
            where 
            event CLK_92;
            process ACT_CLK_err =
                 ( )
               (| (| CLK_145 := when err
                   | CLK_146 := when (not err)
                   |) |)
               where 
               event CLK_146;
               end
            %ACT_CLK_err%; 
            end
         %ACT_CLK_C_err%; 
         process ACT_CLK_bb_1 =
              ( )
            (| CLK_bb_1 ^= bb_1 ^= cc_2
             | (| CLK_x := when (bb_1/=0.0)
                | CLK_x ^= x
                | ACT_CLK_x{}
                | CLK_111 := when (not (bb_1/=0.0))
                |)
             | (| CLK_err2 := when (bb_1=0.0)
                | CLK_err2 ^= err2
                | (| err2 := (cc_2/=0.0) when CLK_err2 |)
                | CLK_123 := when (not (bb_1=0.0))
                |)
             | (| CLK_170 := CLK_x ^+ CLK_err2 |)
             | (| bb_1 := b when CLK_bb_1
                | cc_2 := c when CLK_bb_1
                |)
             |)
            where 
            event CLK_170, CLK_123, CLK_111;
            real bb_1, cc_2;
            process ACT_CLK_x =
                 ( )
               (| CLK_x ^= bb ^= cc
                | (| x := -(cc/bb)
                   | bb := bb_1 when CLK_x
                   | cc := cc_2 when CLK_x
                   |)
                |)
               where 
               real bb, cc;
               end
            %ACT_CLK_x%; 
            end
         %ACT_CLK_bb_1%; 
         end
      %ACT_CLK_a%; 
      process ACT_CLK_x1 =
           ( )
         (| CLK_x1 ^= u
          | (| x1 := u
             | u := (x21 when CLK_x21) default (x when CLK_206)
             |)
          |)
         where 
         real u;
         end
      %ACT_CLK_x1%; 
      end
   %ACT_CLK_C_x%; 
   process SecondDegree_ABS =
        ( ? real a, b, c;
          ! boolean err;
            real x21, x2;
            boolean stable init true, C_y, C_bb, C_err, C_x;
        )
        spec (| (| a --> err
                 | b --> err
                 | c --> err
                 | a --> x21
                 | b --> x21
                 | c --> x21
                 | a --> x2
                 | b --> x2
                 | c --> x2
                 |)
              | (| stable ^= C_y ^= C_x
                 | when stable ^= a ^= b ^= c ^= C_bb
                 | when C_y ^= x2
                 | when C_bb ^= C_err
                 | when C_err ^= err
                 | when C_x ^= x21
                 |)
              |)
      pragmas 
         Black_Box "SecondDegree"
      end pragmas
      external "C"
   %SecondDegree_ABS%; 
   end
%equationSolving_TRA%; 
