process coSim =
     ( ? real a;
         real b;
         real c;
       ! real x1;
         real x2;
         boolean error;
         integer lat;
         integer MaxLat;
         )
  pragmas 
    main
    Defined_clock_hierarchy 
  end pragmas

   (| (| DateGenerator{}
       | (| d_deb := d_c
          | Latency{}
          |) where HomoType d_deb; end
       | MaxLatency{}
       | P_COSTP{}
       |)/ stable, d_x2, d_x1, d_error, dEnd, d_c, d_b, d_a |)
   where 
   use Cost_Context, STD, COSTBIB, M_P_COST; 
   process P_COSTP =
        ( ? real a;
            real b;
            real c;
            HomoType d_a;
            HomoType d_b;
            HomoType d_c;
          ! real x2;
            real x1;
            boolean error;
            boolean stable init true;
            d_x2;
            d_x1;
            d_error;
        )
      (| (| P_SIMU{}
          | P_COST{}
          |)/ C_error, C_cc_381, C_370, C_, C_d, C_331, C_328, error_224, next_stable, OK |)
      where 
      constant real cst_epsilon = 0.0001;
      boolean OK, next_stable, error_224, C_328, C_331, C_d, C_, C_370, C_cc_381, C_error;
      process P_SIMU =
           ( ? real a, b, c;
             ! real x2, x1;
               boolean error, OK, stable init true, next_stable, error_224, C_328, C_331, C_d, C_, C_370, C_cc_381, C_error;
           )
         pragmas 
            main
         end pragmas
         (| (| Tick := true
             | when Tick ^= stable ^= next_stable ^= C_328 ^= C_331
             | ACT_Tick{}
             |) |)
         where 
         constant real cst_epsilon = 0.00001;
         boolean Tick;
         process ACT_Tick =
              ( )
            (| when Tick ^= yy ^= next_yy ^= biterate ^= mx ^= XZX_134 ^= s ^= x_147 ^= C ^= C_y ^= OK_344 ^= C_d_354 ^= C__365 ^= C_cc_387 ^= C__413 ^= C_x ^= C_x1 ^= C_434 ^= C_438 ^= C_442
             | (| when stable ^= a ^= b ^= c ^= OK ^= C_cc
                | ACT_stable{}
                |)
             | (| when C_y ^= x2 ^= x_177
                | ACT_C_y{}
                |)
             | (| when C__413 ^= XZX_164
                | XZX_164 := (bb when OK) cell C__413 init 0.0e0
                |)
             | (| when C_x ^= x_186
                | x_186 := (x_177 when C_y) default (x_88 when C_438)
                |)
             | (| when C_x1 ^= x1
                | x1 := (x_186 when C_x) default (x when C_442)
                |)
             | (| stable := next_stable$1 init true
                | yy := ((d/2.0) when C_d) default (XZX_134 when C_434)
                | next_yy := (((yy+(mx/yy))/2.0) when biterate) default (yy when C)
                | biterate := (true when C_d) default ((not stable) when C_434)
                | mx := (d when C_d) cell Tick init 0.0e0
                | XZX_134 := next_yy$1 init 1.0
                | next_stable := s<cst_epsilon
                | s := (x_147 when C_328) default ((-x_147) when C_331)
                | x_147 := next_yy-yy
                | C := not biterate
                | C_328 := x_147>=0.0
                | C_331 := not (x_147>=0.0)
                | C_y := next_stable and biterate
                | OK_344 := left_tt(OK,stable)
                | C_d_354 := left_tt(C_d,stable)
                | C__365 := left_tt(C_,stable)
                | C_cc_387 := left_tt(C_cc_381,stable)
                | C__413 := C_y or OK_344
                | C_x := C_y or C__365
                | C_x1 := C_x or C_cc_387
                | C_434 := not C_d_354
                | C_438 := (not C_y) and C__365
                | C_442 := (not C_x) and C_cc_387
                |)
             |)
            where 
            real x, bb, d, x_88, yy, next_yy;
            boolean biterate;
            real mx, XZX_134, s, x_147, XZX_164, x_177, x_186;
            boolean C, C_y, OK_344, C_cc, C_d_354, C__365, C_cc_387, C__413, C_x, C_x1, C_434, C_438, C_442;
            process ACT_stable =
                 ( )
               (| when stable ^= C_373 ^= C_error_395 ^= C_err
                | (| when OK ^= bb ^= C_d ^= C_ ^= C_370
                   | ACT_OK{}
                   | when C_cc ^= C_cc_381 ^= C_error
                   | ACT_C_cc{}
                   |)
                | (| when C_err ^= error
                   | ACT_C_err{}
                   |)
                | (| OK := a/=0.0
                   | C_cc := not OK
                   | C_373 := left_tt(C_370,OK)
                   | C_error_395 := left_tt(C_error,C_cc)
                   | C_err := C_373 or C_error_395
                   |)
                |)
               where 
               boolean C_373, C_error_395, C_err;
               process ACT_OK =
                    ( )
                  (| when OK ^= cc ^= dd ^= aa ^= XZX ^= XZX_84
                   | (| when C_d ^= d
                      | d := dd when C_d
                      |)
                   | (| when C_ ^= x_88
                      | ACT_C_{}
                      |)
                   | (| bb := XZX/aa
                      | cc := XZX_84/aa
                      | dd := (bb*bb)-(4.0*cc)
                      | aa := a when OK
                      | XZX := b when OK
                      | XZX_84 := c when OK
                      | C_d := dd>0.0
                      | C_ := dd=0.0
                      | C_370 := dd<0.0
                      |)
                   |)
                  where 
                  real cc, dd, aa, XZX, XZX_84;
                  process ACT_C_ =
                       ( )
                     (| when C_ ^= XZX_91
                      | (| x_88 := (-XZX_91)/2.0
                         | XZX_91 := bb when C_
                         |)
                      |)
                     where 
                     real XZX_91;
                     end
                  ; 
                  end
               ; 
               process ACT_C_cc =
                    ( )
                  (| when C_cc ^= bb_229 ^= cc_230
                   | (| when C_cc_381 ^= x
                      | ACT_C_cc_381{}
                      |)
                   | (| when C_error ^= error_224
                      | error_224 := (cc_230/=0.0) when C_error
                      |)
                   | (| bb_229 := b when C_cc
                      | cc_230 := c when C_cc
                      | C_cc_381 := bb_229/=0.0
                      | C_error := bb_229=0.0
                      |)
                   |)
                  where 
                  real bb_229, cc_230;
                  process ACT_C_cc_381 =
                       ( )
                     (| when C_cc_381 ^= bb_212 ^= cc_213
                      | (| x := -(cc_213/bb_212)
                         | bb_212 := bb_229 when C_cc_381
                         | cc_213 := cc_230 when C_cc_381
                         |)
                      |)
                     where 
                     real bb_212, cc_213;
                     end
                  ; 
                  end
               ; 
               process ACT_C_err =
                    ( )
                  (| when C_err ^= err_235
                   | (| error := err_235
                      | err_235 := (true when C_370) default (error_224 when C_error)
                      |)
                   |)
                  where 
                  boolean err_235;
                  end
               ; 
               end
            ; 
            process ACT_C_y =
                 ( )
               (| when C_y ^= y ^= bb_110 ^= x_168
                | (| x2 := x_168
                   | y := yy when C_y
                   | bb_110 := XZX_164 when C_y
                   | x_168 := -((bb_110-y)/2.0)
                   | x_177 := -((bb_110+y)/2.0)
                   |)
                |)
               where 
               real y, bb_110, x_168;
               end
            ; 
            end
         ; 
         end
      ; 
      end
   ; 
   process DateGenerator =
        ( ? dEnd;
          ! d_a;
            HomoType d_b;
            HomoType d_c;
        )
      (| d := ((dEnd$ init NilHomoTypeValue) when (^d_a))+(d$ init NilHomoTypeValue)
       | d_a := d
       | d_b := d
       | d_c := d
       |)
      where 
      HomoType d;
      end
   ; 
   process MaxLatency =
        ( ? HomoType lat;
          ! HomoType MaxLat;
        )
      (| MaxLat := (lat when (lat>ZMaxLat)) default ZMaxLat
       | ZMaxLat := MaxLat$1 init NilHomoTypeValue
       | ZMaxLat ^= lat
       |)
      where 
      HomoType ZMaxLat;
      end
   ; 
   process Latency =
        ( ? d_deb;
            boolean stable;
            HomoType d_x1;
            HomoType d_x2;
            HomoType d_error;
          ! HomoType dEnd;
            HomoType lat;
        )
      (| d_end := MAX(MAX(d_x1,d_x2),d_error)
       | dEnd := d_end cell (^stable)
       | l := dEnd-(d_deb cell (^stable))
       | lat := l when (^d_end)
       |)
      where 
      HomoType l, d_end;
      process MAX =
           ( ? HomoType IN1;
               HomoType IN2;
             ! HomoType MAX_VAL;
           )
         (| HCOMMON := (when (^IN1)) when (^IN2)
          | c1 := IN1 when HCOMMON
          | c2 := IN2 when HCOMMON
          | MAX_VAL := (IN1 when (c1>c2)) default IN2 default IN1
          |)
         where 
         event HCOMMON;
         HomoType c1, c2;
         end
      ; 
      end
   ; 
   HomoType d_a, d_b, d_c, dEnd, d_error, d_x1, d_x2;
   boolean stable init true;
   end
; 
