process FirstDegree_ABSTRACT =
     ( ? boolean Compute;
         real b, c;
       ! real x;
         boolean err2, C_bb, C_error;
     )
   pragmas 
      Grey_Box "FirstDegree"
   end pragmas
   (| (| Tick := true
       | when Tick ^= Compute ^= b ^= c
       | when Compute ^= C_bb ^= C_error
       | when C_bb ^= x
       | when C_error ^= err2
       |)
    | (| nlabel :: (x,err2) := FirstDegree_Cluster_1(Compute)
       | nlabel ^= when Compute
       |)
    | (| nlabel_71 :: FirstDegree_Cluster_2(Compute,c)
       | nlabel_71 ^= when Tick
       |)
    | (| nlabel_72 :: (C_bb,C_error) := FirstDegree_Cluster_3(Compute,b)
       | nlabel_72 ^= when Tick
       |)
    | (| c --> nlabel
       | b --> nlabel
       | Compute --> nlabel
       | nlabel_71 --> nlabel
       | c --> nlabel_71
       | Compute --> nlabel_71
       | nlabel_72 --> nlabel
       | b --> nlabel_72
       | Compute --> nlabel_72
       |)
    |)
   where 
   boolean Tick;
   label nlabel, nlabel_71, nlabel_72; 
   action FirstDegree_Cluster_1 =
        ( ? boolean Compute;
          ! real x;
            boolean err2;
        )
      pragmas 
         Cluster
         Black_Box ""
      end pragmas
      external "C"
   %FirstDegree_Cluster_1%; 
   action FirstDegree_Cluster_2 =
        ( ? boolean Compute;
            real c;
        )
      pragmas 
         Cluster
         Black_Box ""
      end pragmas
      external "C"
   %FirstDegree_Cluster_2%; 
   action FirstDegree_Cluster_3 =
        ( ? boolean Compute;
            real b;
          ! boolean C_bb;
            boolean C_error;
        )
      pragmas 
         Cluster
         Black_Box ""
      end pragmas
      external "C"
   %FirstDegree_Cluster_3%; 
   end
%FirstDegree_ABSTRACT%; 
