process SecondDegree_TRA =
     ( ? boolean OK;
         real a, b, c;
       ! event err;
         real x21, x2;
     )
   pragmas 
      main
   end pragmas
   (| (| CLK_stable := ^CLK_stable
       | ACT_CLK_stable{}
       |)
    | (| {c --> x21} when CLK_1031
       | {c --> x2} when CLK_1027
       | {b --> x21} when CLK_1031
       | {b --> x2} when CLK_1027
       | {a --> OK} when CLK_OK
       | {a --> x21} when CLK_1031
       | {a --> x2} when CLK_1027
       | {OK --> x21} when CLK_1033
       | {OK --> x2} when CLK_1029
       |)
    |)
   where 
   constant real epsilon = 0.000001;
   event CLK_stable;
   process ACT_CLK_stable =
        ( )
      (| CLK_stable ^= stable ^= yy ^= next_yy ^= biterate ^= mx ^= pre_next_yy ^= next_stable ^= s ^= XZX_773
       | (| CLK_721 := when biterate
          | CLK_722 := when (not biterate)
          |)
       | (| CLK_738 := when (XZX_773>=0.0)
          | CLK_739 := when (not (XZX_773>=0.0))
          |)
       | (| CLK_x2 := when (next_stable and biterate)
          | CLK_x2 ^= x2 ^= x1
          | ACT_CLK_x2{}
          | CLK_746 := when (not (next_stable and biterate))
          |)
       | (| CLK_a := when stable
          | CLK_a ^= a ^= b ^= c
          | ACT_CLK_a{}
          | CLK_777 := when (not stable)
          |)
       | (| CLK_793 := CLK_x2 ^+ CLK_a |)
       | (| CLK_XZX_792 := CLK_x2 ^+ CLK_bb
          | CLK_XZX_792 ^= XZX_792
          | (| XZX_792 := (bb when CLK_bb) cell CLK_XZX_792 init 0.0e0 |)
          |)
       | (| CLK_x21 := CLK_x2 ^+ CLK_x
          | CLK_x21 ^= x21
          | ACT_CLK_x21{}
          |)
       | (| CLK_799 := CLK_x ^- CLK_x2 |)
       | (| CLK_802 := CLK_stable ^- CLK_d |)
       | (| CLK_987 := CLK_721 ^* CLK_d |)
       | (| CLK_1027 := CLK_x2 ^* CLK_a |)
       | (| CLK_1029 := CLK_x2 ^* CLK_OK |)
       | (| CLK_1031 := CLK_a ^* CLK_x21 |)
       | (| CLK_1033 := CLK_x21 ^* CLK_OK |)
       | (| stable := next_stable$1 init true
          | yy := ((d/2.0) when CLK_d) default (pre_next_yy when CLK_802)
          | next_yy := (((yy+(mx/yy))/2.0) when CLK_721) default (yy when CLK_722)
          | biterate := CLK_d default ((not stable) when CLK_802)
          | mx := (d when CLK_d) cell CLK_stable init 0.0e0
          | pre_next_yy := next_yy$1 init 1.0
          | next_stable := s<epsilon
          | s := (XZX_773 when CLK_738) default ((-XZX_773) when CLK_739)
          | XZX_773 := next_yy-yy
          |)
       |)
      where 
      event CLK_1033, CLK_1031, CLK_1029, CLK_1027, CLK_987, CLK_802, CLK_799, CLK_x21, CLK_XZX_792, CLK_793, CLK_777, CLK_a, CLK_746, CLK_x2, CLK_739, CLK_738, CLK_722, CLK_721, CLK_OK, CLK_bb, CLK_x, CLK_d;
      boolean stable, biterate, next_stable;
      real d, bb, x, yy, next_yy, mx, pre_next_yy, s, XZX_773, XZX_792, x1;
      process ACT_CLK_x2 =
           ( )
         (| CLK_x2 ^= y ^= bb_733 ^= x_796
          | (| x2 := x_796
             | y := yy when CLK_x2
             | bb_733 := XZX_792 when CLK_x2
             | x_796 := -((bb_733-y)/2.0)
             | x1 := -((bb_733+y)/2.0)
             |)
          |)
         where 
         real y, bb_733, x_796;
         end
      ; 
      process ACT_CLK_a =
           ( )
         (| (| CLK_OK := when (a/=0.0)
             | CLK_OK ^= OK
             | ACT_CLK_OK{}
             | CLK_696 := when (not (a/=0.0))
             |) |)
         where 
         event CLK_696;
         process ACT_CLK_OK =
              ( )
            (| (| CLK_bb := when OK
                | CLK_bb ^= bb
                | ACT_CLK_bb{}
                | CLK_686 := when (not OK)
                |) |)
            where 
            event CLK_686;
            process ACT_CLK_bb =
                 ( )
               (| CLK_bb ^= cc ^= dd ^= aa ^= XZX ^= XZX_699
                | (| CLK_d := when (dd>0.0)
                   | CLK_d ^= d
                   | (| d := dd when CLK_d |)
                   | CLK := when (not (dd>0.0))
                   |)
                | (| CLK_x := when (dd=0.0)
                   | CLK_x ^= x
                   | ACT_CLK_x{}
                   | CLK_675 := when (not (dd=0.0))
                   |)
                | (| err := when (dd<0.0)
                   | err ^= err
                   | CLK_677 := when (not (dd<0.0))
                   |)
                | (| CLK_786 := CLK_x ^+ err |)
                | (| CLK_788 := CLK_d ^+ CLK_786 |)
                | (| CLK_790 := CLK_d ^+ err |)
                | (| bb := XZX/aa
                   | cc := XZX_699/aa
                   | dd := (bb*bb)-(4.0*cc)
                   | aa := a when CLK_bb
                   | XZX := b when CLK_bb
                   | XZX_699 := c when CLK_bb
                   |)
                |)
               where 
               event CLK_790, CLK_788, CLK_786, CLK_677, CLK_675, CLK;
               real cc, dd, aa, XZX, XZX_699;
               process ACT_CLK_x =
                    ( )
                  (| CLK_x ^= XZX_708
                   | (| x := (-XZX_708)/2.0
                      | XZX_708 := bb when CLK_x
                      |)
                   |)
                  where 
                  real XZX_708;
                  end
               ; 
               end
            ; 
            end
         ; 
         end
      ; 
      process ACT_CLK_x21 =
           ( )
         (| CLK_x21 ^= x_814
          | (| x21 := x_814
             | x_814 := (x1 when CLK_x2) default (x when CLK_799)
             |)
          |)
         where 
         real x_814;
         end
      ; 
      end
   ; 
   end
; 
