module M_Q1_COST =
   type HomoType = external;
   constant HomoType NilHomoTypeValue = external;
   constant HomoType d_epsilon = external;
   process Q1_COST =
        ( ? boolean err2, stable, next_stable, OK, C_d, C_, C_cc_391, C_380, C_error_405, C_cc, C_error, C_338, C_335;
            HomoType d_c, d_b, d_a, d_x, d_err2, d_C_cc, d_C_cc_391, d_C_error, d_C_error_405;
          ! HomoType d_error, d_x1, d_x2, d_OK, d_stable, d_C_y, d_C_x1, d_C_error_323;
        )
      pragmas 
         main
         Defined_clock_hierarchy
      end pragmas
      (| (| CLK_stable_0 := ^stable
          | CLK_stable_0 ^= stable ^= next_stable ^= C_338 ^= C_335 ^= d_stable ^= d_C_y ^= d_C_x1
          | CLK_stable_0 ^= biterate ^= C ^= C_y ^= OK_354 ^= C_d_364 ^= C__375 ^= C_cc_397 ^= C__429 ^= C_x21 ^= C_x1 ^= C_469 ^= C_473 ^= C_476 ^= OK_238 ^= C_d_247 ^= C__256 ^= C_cc_268 ^= C_cc_391_277 ^= C_356 ^= C_365 ^= C_371 ^= C_375 ^= C_378 ^= 
            C_381 ^= C_384 ^= C_387 ^= C_394 ^= C_397 ^= C_409 ^= C_412 ^= C_415 ^= C_418 ^= C_427 ^= C_430 ^= C_439 ^= C_445 ^= C_451 ^= C_454 ^= C_460 ^= d_stable_internal ^= d_next_stable ^= d_yy ^= d_pre_next_yy ^= d_mx ^= d_next_yy ^= d_biterate ^= 
            d_s ^= d_XZX_164 ^= d_C ^= d_C_335 ^= d_C_338 ^= d_C_y_internal ^= d_OK_354 ^= d_C_d_364 ^= d_C__375 ^= d_C_cc_397 ^= d_C__429 ^= d_C_x21 ^= d_C_x1_internal ^= d_C_469 ^= d_C_473 ^= d_C_476 ^= d_OK_238 ^= d_C_d_247 ^= d_C__256 ^= d_C_cc_268 ^= 
            d_C_cc_391_277 ^= d_C_356 ^= d_C_365 ^= d_C_371 ^= d_C_375 ^= d_C_378 ^= d_C_381 ^= d_C_384 ^= d_C_387 ^= d_C_394 ^= d_C_397 ^= d_C_409 ^= d_C_412 ^= d_C_415 ^= d_C_418 ^= d_C_427 ^= d_C_430 ^= d_C_439 ^= d_C_445 ^= d_C_451 ^= d_C_454 ^= 
            d_C_460 ^= d_nlabel_475 ^= d_nlabel_476 ^= d_nlabel_477 ^= d_nlabel_479 ^= d_nlabel_480 ^= d_nlabel_483 ^= d_CLK_stable_0 ^= done_1259 ^= done_1262 ^= done_1291 ^= done_1302 ^= done_1314 ^= done_1333 ^= done_1336 ^= done_1340 ^= done_1344 ^= 
            done_1348 ^= done_1352 ^= done_1356 ^= done_1364 ^= done_1370 ^= done_1374 ^= done_1383 ^= done_1395 ^= done_1406 ^= done_1415 ^= done_1425 ^= done_1436 ^= done_1442 ^= done_1446 ^= done_1465 ^= done_1481 ^= done_1491 ^= done_1500 ^= done_1505 
            ^= done_1511 ^= XZX_1514 ^= done_1515 ^= XZX_1526 ^= done_1527 ^= done_1537 ^= done_1558 ^= done_1569 ^= done_1580 ^= done_1586 ^= done_1591 ^= done_1602 ^= done_1608 ^= XZX_1611 ^= done_1612 ^= XZX_1623 ^= done_1624 ^= XZX_1633 ^= done_1634 ^=
            XZX_1646 ^= XZX_1652 ^= done_1653 ^= XZX_1665 ^= done_1666 ^= done_1685 ^= XZX_1693 ^= done_1694 ^= XZX_1703 ^= done_1704 ^= XZX_1713 ^= done_1714 ^= done_1735 ^= XZX_1738 ^= done_1739 ^= XZX_1748 ^= done_1749 ^= XZX_1761 ^= done_1762 ^= 
            done_1773 ^= done_1786 ^= done_1792 ^= XZX_1803 ^= done_1810 ^= XZX_1815 ^= done_1816 ^= XZX_1828 ^= done_1836 ^= done_1843 ^= done_1852 ^= done_1862 ^= done_1868 ^= XZX_1871 ^= done_1872 ^= XZX_1888 ^= done_1889 ^= done_1900 ^= done_1918 ^= 
            XZX_1926 ^= done_1927 ^= XZX_1943 ^= done_1944 ^= done_1955 ^= done_1962 ^= done_1969 ^= XZX_1975 ^= done_1976 ^= done_1984 ^= done_2007 ^= done_2026 ^= done_2047 ^= done_2062 ^= done_2080 ^= done_2099 ^= done_2115 ^= done_2125 ^= done_2141 ^= 
            done_2154 ^= done_2161 ^= XZX_2173 ^= done_2174 ^= done_2182 ^= XZX_2188 ^= done_2189 ^= done_2197 ^= XZX_2203 ^= done_2204 ^= done_2212 ^= XZX_2218 ^= done_2219 ^= done_2227 ^= done_2240 ^= done_2247 ^= done_2277 ^= done_2280 ^= done_2283 ^= 
            done_2288 ^= done_2292 ^= done_2296 ^= done_2300 ^= done_2304 ^= done_2308 ^= done_2312 ^= done_2320 ^= done_2339 ^= done_2346 ^= done_2356 ^= done_2363 ^= done_2373 ^= done_2376 ^= done_2380 ^= done_2415 ^= done_2418 ^= done_2439 ^= XZX_2448 
            ^= done_2449 ^= XZX_2465 ^= done_2466 ^= done_2477 ^= done_2489 ^= done_2492 ^= done_2497 ^= done_2501 ^= done_2505 ^= done_2512 ^= done_2520 ^= XZX_2526 ^= done_2527 ^= done_2535 ^= done_2542 ^= XZX_2548 ^= done_2549 ^= done_2557 ^= done_2564 
            ^= done_2572 ^= done_2580 ^= done_2588 ^= done_2603 ^= done_2606 ^= done_2610 ^= done_2614 ^= done_2618 ^= done_2622 ^= done_2641 ^= done_2708 ^= done_2716 ^= done_2731 ^= done_2753 ^= done_2797 ^= done_2841 ^= done_2868 ^= done_2879 ^= 
            done_2906 ^= done_2914 ^= done_2922 ^= done_2930 ^= done_2938 ^= done_2946 ^= done_2954 ^= done_2962 ^= done_2970 ^= done_2986 ^= done_2994 ^= done_3002 ^= done_3010 ^= done_3018 ^= done_3030 ^= done_3038 ^= done_3046 ^= done_3054 ^= done_3062 
            ^= done_3070 ^= done_3078 ^= done_3086 ^= done_3094 ^= done_3175 ^= done_3181 ^= done_3187 ^= done_3198 ^= done_3209 ^= done_3215 ^= done_3231 ^= done_3242 ^= done_3248 ^= done_3273 ^= done_3283 ^= done_3289
          |)
       | (| CLK := when biterate
          | CLK ^= d_CLK
          |)
       | (| CLK_c_0 := when stable
          | CLK_c_0 ^= OK ^= C_error_405 ^= C_cc ^= d_c ^= d_b ^= d_a ^= d_C_cc ^= d_C_error_405 ^= d_OK ^= d_C_error_323 ^= d_c_internal ^= d_b_internal ^= d_a_internal ^= d_C_cc_internal ^= d_C_error_405_internal ^= d_OK_internal ^= d_C_383 ^= 
            d_C_380_262 ^= d_C_error_323_internal ^= d_C_391 ^= d_nlabel ^= d_nlabel_478 ^= d_nlabel_481 ^= d_nlabel_482 ^= d_nlabel_484 ^= d_nlabel_485 ^= d_nlabel_486 ^= d_CLK_c_0 ^= done_1282 ^= done_2431 ^= done_2652 ^= done_2701 ^= done_2762 ^= 
            done_2807 ^= done_2860
          | CLK_c_0 ^= C_383 ^= C_error_438 ^= C_380_262 ^= C_error_283 ^= C_error_323 ^= C_391 ^= C_433 ^= C_436 ^= C_466 ^= d_C_error_438 ^= d_C_error_283 ^= d_C_433 ^= d_C_436 ^= d_C_466 ^= done ^= done_1222 ^= done_1234 ^= done_1266 ^= done_1270 ^= 
            done_1274 ^= done_1278 ^= XZX_2332 ^= done_2387 ^= done_2396 ^= done_2423 ^= done_2427 ^= done_2629 ^= done_2648 ^= done_2659 ^= done_2669 ^= done_2693 ^= done_2697 ^= done_2739 ^= done_2758 ^= done_2769 ^= done_2777 ^= XZX_2783 ^= done_2784 ^=
            done_2803 ^= done_2813 ^= done_2821 ^= done_2828 ^= done_2848 ^= done_2852 ^= done_2856
          |)
       | (| CLK_bb := when OK
          | CLK_bb ^= C_d ^= C_ ^= C_380 ^= d_bb ^= d_C_d ^= d_C_ ^= d_C_380 ^= d_dd ^= d_aa ^= d_XZX_99 ^= d_XZX_103 ^= d_cc ^= d_CLK_bb ^= XZX_1568 ^= XZX_2025 ^= XZX_2046
          | CLK_bb ^= XZX_1855 ^= XZX_1911 ^= XZX_2000 ^= XZX_2039
          |)
       | (| CLK_d_0 := when C_d
          | CLK_d_0 ^= d_d ^= d_CLK_d_0 ^= XZX_1536 ^= XZX_1590
          | CLK_d_0 ^= XZX_1549 ^= XZX_1723
          |)
       | (| CLK_x0_0 := when C_
          | CLK_x0_0 ^= d_x0 ^= d_XZX_109 ^= d_CLK_x0_0 ^= XZX_1424
          | CLK_x0_0 ^= XZX_1418
          |)
       | (| CLK_24 := when C_380
          | CLK_24 ^= d_CLK_24
          | CLK_24 ^= XZX_1244
          |)
       | (| CLK_C_cc_391_0 := when C_cc
          | CLK_C_cc_391_0 ^= C_cc_391 ^= C_error ^= d_C_cc_391 ^= d_C_error ^= d_C_cc_391_internal ^= d_C_error_internal ^= d_CLK_C_cc_391_0
          |)
       | (| CLK_x_0 := when C_cc_391
          | CLK_x_0 ^= d_x ^= d_x_internal ^= d_CLK_x_0
          |)
       | (| CLK_err2_0 := when C_error
          | CLK_err2_0 ^= err2 ^= d_err2 ^= d_err2_internal ^= d_CLK_err2_0
          |)
       | (| CLK_46 := when C_error_438
          | CLK_46 ^= XZX ^= XZX_1233
          |)
       | (| CLK_error_0 := when C_error_323
          | CLK_error_0 ^= d_error ^= d_error_internal ^= d_CLK_error_1
          |)
       | (| CLK_217 := when C_391
          | CLK_217 ^= d_CLK_871
          |)
       | (| nlabel :: Q1_Cluster_1_M{}
          | nlabel ^= CLK_c_0
          |)
       | (| nlabel_478 :: Q1_Cluster_5_M{}
          | nlabel_478 ^= CLK_c_0
          |)
       | (| nlabel_481 :: Q1_Cluster_8_M{}
          | nlabel_481 ^= CLK_c_0
          |)
       | (| nlabel_482 :: Q1_Cluster_9_M{}
          | nlabel_482 ^= CLK_c_0
          |)
       | (| nlabel_484 :: Q1_Cluster_11_M{}
          | nlabel_484 ^= CLK_c_0
          |)
       | (| nlabel_485 :: Q1_Cluster_12_M{}
          | nlabel_485 ^= CLK_c_0
          |)
       | (| nlabel_486 :: Q1_Cluster_13_M{}
          | nlabel_486 ^= CLK_c_0
          |)
       | (| C_383 := left_tt ( C_380,OK )
          | C_error_438 := C_383 or C_error_405
          | C_380_262 := left_tt ( C_380,OK )
          | C_error_283 := left_tt ( C_error,C_cc )
          | C_error_323 := C_380_262 or C_error_283
          | C_391 := (not C_380_262) and C_error_283
          | C_433 := C_391 or C_error_438
          | C_436 := C_433 or C_380_262
          | C_466 := C_error_323 and C_error_438
          | done_1266 := pack(d_C_error_internal,d_err2_internal)
          | done_1270 := pack(d_C_380,done_1266)
          | done_1274 := pack(d_C_error_438,done_1270)
          | done_1278 := pack(d_C_error_323_internal,done_1274)
          | done_1282 := pack(d_C_391,done_1278)
          | done_2423 := pack(d_OK_internal,d_b_internal)
          | done_2427 := pack(d_stable_internal,done_2423)
          | done_2431 := pack(d_aa,done_2427)
          | done_2648 := pack(d_stable_internal,d_C_error_405_internal)
          | done_2652 := pack(d_C_383,done_2648)
          | done_2693 := pack(d_OK_internal,d_c_internal)
          | done_2697 := pack(d_stable_internal,done_2693)
          | done_2701 := pack(d_aa,done_2697)
          | done_2758 := pack(d_C_error_internal,d_C_cc_internal)
          | done_2762 := pack(d_stable_internal,done_2758)
          | done_2803 := pack(d_C_380_262,d_stable_internal)
          | done_2807 := pack(d_C_error_283,done_2803)
          | done_2848 := pack(d_C_error_438,d_stable_internal)
          | done_2852 := pack(d_C_380_262,done_2848)
          | done_2856 := pack(d_C_error_323_internal,done_2852)
          | done_2860 := pack(d_C_391,done_2856)
          |)
       | (| CLK_65 := when C_335
          | CLK_65 ^= d_CLK_65
          |)
       | (| CLK_x2_0 := when C_y
          | CLK_x2_0 ^= d_x2 ^= d_x2_internal ^= d_x_194 ^= d_x_185 ^= d_y ^= d_bb_127 ^= d_CLK_x2_0 ^= XZX_1445 ^= XZX_1464 ^= XZX_2079 ^= XZX_2098
          | CLK_x2_0 ^= XZX_1458 ^= XZX_2092
          |)
       | (| CLK_XZX_181_0 := when C__429
          | CLK_XZX_181_0 ^= d_XZX_181 ^= d_CLK_XZX_181_0
          |)
       | (| CLK_x21_0 := when C_x21
          | CLK_x21_0 ^= d_x21 ^= d_CLK_x21_0 ^= XZX_1382 ^= XZX_1394
          |)
       | (| CLK_x1_0 := when C_x1
          | CLK_x1_0 ^= d_x1 ^= d_x1_internal ^= d_CLK_x1_0 ^= XZX_1301 ^= XZX_1313
          |)
       | (| CLK_207 := when C_375
          | CLK_207 ^= d_CLK_861
          |)
       | (| CLK_209 := when C_378
          | CLK_209 ^= d_CLK_863
          |)
       | (| CLK_211 := when C_381
          | CLK_211 ^= d_CLK_865
          |)
       | (| CLK_213 := when C_384
          | CLK_213 ^= d_CLK_867
          |)
       | (| CLK_215 := when C_387
          | CLK_215 ^= d_CLK_869
          |)
       | (| CLK_220 := when C_394
          | CLK_220 ^= d_CLK_873
          | CLK_220 ^= XZX_2458
          |)
       | (| CLK_222 := when C_397
          | CLK_222 ^= d_CLK_875
          | CLK_222 ^= XZX_1881 ^= XZX_1936
          |)
       | (| nlabel_475 :: Q1_Cluster_2_M{}
          | nlabel_475 ^= CLK_stable_0
          |)
       | (| nlabel_476 :: Q1_Cluster_3_M{}
          | nlabel_476 ^= CLK_stable_0
          |)
       | (| nlabel_477 :: Q1_Cluster_4_M{}
          | nlabel_477 ^= CLK_stable_0
          |)
       | (| nlabel_479 :: Q1_Cluster_6_M{}
          | nlabel_479 ^= CLK_stable_0
          |)
       | (| nlabel_480 :: Q1_Cluster_7_M{}
          | nlabel_480 ^= CLK_stable_0
          |)
       | (| nlabel_483 :: Q1_Cluster_10_M{}
          | nlabel_483 ^= CLK_stable_0
          |)
       | (| nlabel_529 :: Q1_Cluster_delays_M{}
          | nlabel_529 ^= CLK_stable_0
          |)
       | (| biterate := CLK_d_0 default ((not stable) when CLK_207)
          | C := not biterate
          | C_y := next_stable and biterate
          | OK_354 := left_tt ( OK,stable )
          | C_d_364 := (C_d when CLK_bb) default (not CLK_222)
          | C__375 := (C_ when CLK_bb) default (not CLK_222)
          | C_cc_397 := (C_cc_391 when CLK_C_cc_391_0) default (not CLK_220)
          | C__429 := C_y or OK_354
          | C_x21 := C_y or C__375
          | C_x1 := C_x21 or C_cc_397
          | C_469 := (not C_y) and C__375
          | C_473 := (not C_x21) and C_cc_397
          | C_476 := not C_d_364
          | OK_238 := left_tt ( OK,stable )
          | C_d_247 := left_tt ( C_d,stable )
          | C__256 := left_tt ( C_,stable )
          | C_cc_268 := left_tt ( C_cc,stable )
          | C_cc_391_277 := left_tt ( C_cc_391,stable )
          | C_356 := C_469 and C__256
          | C_365 := C_473 and C_cc_391_277
          | C_371 := C_476 or C_d_247
          | C_375 := (not C_d_247) and C_476
          | C_378 := (not C_x21) and C_365
          | C_381 := (not C_y) and C_356
          | C_384 := (not C_335) and C_338
          | C_387 := (not biterate) and C
          | C_394 := not C_cc_268
          | C_397 := not OK_238
          | C_409 := C_371 or biterate
          | C_412 := C_409 or C_387
          | C_415 := C_412 or C_335
          | C_418 := C_415 or C_384
          | C_427 := C_x21 or C_x1
          | C_430 := C_427 or C_378
          | C_439 := C_418 or OK_238
          | C_445 := C_378 or C_x1
          | C_451 := stable and C_y
          | C_454 := C_x1 and C_cc_268
          | C_460 := stable and C_x1
          | (d_nlabel,done_1259) := CostSubGraph(done_1282,d_error_internal,d_CLK_c_0,done_1262)
          | done_1340 := pack(d_C_cc_391_internal,d_x_internal)
          | done_1344 := pack(d_x21,done_1340)
          | done_1348 := pack(d_C_x21,done_1344)
          | done_1352 := pack(d_C_x1_internal,done_1348)
          | done_1356 := pack(d_C_378,done_1352)
          | (d_nlabel_475,done_1333) := CostSubGraph(done_1356,d_x1_internal,d_CLK_stable_0,done_1336)
          | done_2283 := pack(d_C_y_internal,d_x2_internal)
          | done_2288 := pack(d_stable_internal,d_OK_internal)
          | done_2292 := pack(d_bb,done_2288)
          | done_2296 := pack(d_pre_next_yy,done_2292)
          | done_2300 := pack(d_OK_354,done_2296)
          | done_2304 := pack(d_cc,done_2300)
          | done_2308 := pack(d_OK_238,done_2304)
          | done_2312 := pack(d_C_397,done_2308)
          | (d_nlabel_476,done_2277) := CostSubGraph(done_2312,done_2283,d_CLK_stable_0,done_2280)
          | done_2380 := pack(d_stable_internal,d_a_internal)
          | (d_nlabel_477,done_2373) := CostSubGraph(done_2380,d_OK_internal,d_CLK_stable_0,done_2376)
          | (d_nlabel_478,done_2415) := CostSubGraph(done_2431,NilHomoTypeValue when CLK_c_0,d_CLK_c_0,done_2418)
          | done_2497 := pack(d_C_cc_391_internal,d_C_cc_internal)
          | done_2501 := pack(d_stable_internal,done_2497)
          | done_2505 := pack(d_C_394,done_2501)
          | (d_nlabel_479,done_2489) := CostSubGraph(done_2505,NilHomoTypeValue when CLK_stable_0,d_CLK_stable_0,done_2492)
          | done_2610 := pack(d_C_cc_397,d_stable_internal)
          | done_2614 := pack(d_C_x21,done_2610)
          | done_2618 := pack(d_C_cc_268,done_2614)
          | done_2622 := pack(d_C_cc_391_277,done_2618)
          | (d_nlabel_480,done_2603) := CostSubGraph(done_2622,d_C_x1_internal,d_CLK_stable_0,done_2606)
          | (d_nlabel_481,done_2641) := CostSubGraph(done_2652,NilHomoTypeValue when CLK_c_0,d_CLK_c_0,done_1333)
          | (d_nlabel_482,done_2280) := CostSubGraph(done_2701,NilHomoTypeValue when CLK_c_0,d_CLK_c_0,done_2415)
          | done_2731 := pack(d_stable_internal,d_C_cc_internal)
          | (d_nlabel_483,done_2492) := CostSubGraph(done_2731,NilHomoTypeValue when CLK_stable_0,d_CLK_stable_0,done_2373)
          | (d_nlabel_484,done_2376) := CostSubGraph(done_2762,NilHomoTypeValue when CLK_c_0,d_CLK_c_0,done_2753)
          | (d_nlabel_485,done_2797) := CostSubGraph(done_2807,d_C_error_323_internal,d_CLK_c_0,done_2641)
          | (d_nlabel_486,done_2841) := CostSubGraph(done_2860,NilHomoTypeValue when CLK_c_0,d_CLK_c_0,done_1259)
          | (d_CLK,done_2906) := CostWhen1(d_biterate,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_CLK_c_0,done_2914) := CostWhen1(d_stable_internal,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_CLK_bb,done_2922) := CostWhen1(d_OK_internal,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
          | (d_CLK_d_0,done_2930) := CostWhen1(d_C_d,d_CLK_bb,NilHomoTypeValue when CLK_bb)
          | (d_CLK_x0_0,done_2938) := CostWhen1(d_C_,d_CLK_bb,NilHomoTypeValue when CLK_bb)
          | (d_CLK_24,done_2946) := CostWhen1(d_C_380,d_CLK_bb,NilHomoTypeValue when CLK_bb)
          | (d_CLK_C_cc_391_0,done_2954) := CostWhen1(d_C_cc_internal,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
          | (d_CLK_x_0,done_2962) := CostWhen1(d_C_cc_391_internal,d_CLK_C_cc_391_0,NilHomoTypeValue when CLK_C_cc_391_0)
          | (d_CLK_err2_0,done_2970) := CostWhen1(d_C_error_internal,d_CLK_C_cc_391_0,NilHomoTypeValue when CLK_C_cc_391_0)
          | (d_CLK_65,done_2986) := CostWhen1(d_C_335,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_CLK_x2_0,done_2994) := CostWhen1(d_C_y_internal,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_CLK_XZX_181_0,done_3002) := CostWhen1(d_C__429,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_CLK_x21_0,done_3010) := CostWhen1(d_C_x21,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_CLK_x1_0,done_3018) := CostWhen1(d_C_x1_internal,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | d_CLK_stable_0 := CostConst{__TC__#_event}()
          | (d_CLK_error_1,done_3030) := CostWhen1(d_C_error_323_internal,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
          | (d_CLK_861,done_3038) := CostWhen1(d_C_375,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_CLK_863,done_3046) := CostWhen1(d_C_378,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_CLK_865,done_3054) := CostWhen1(d_C_381,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_CLK_867,done_3062) := CostWhen1(d_C_384,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_CLK_869,done_3070) := CostWhen1(d_C_387,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_CLK_871,done_3078) := CostWhen1(d_C_391,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
          | (d_CLK_873,done_3086) := CostWhen1(d_C_394,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_CLK_875,done_3094) := CostWhen1(d_C_397,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_c_internal,done_3175) := CostInput{__TC__#_real}(d_c,d_CLK_c_0,done_3181)
          | (d_b_internal,done_3187) := CostInput{__TC__#_real}(d_b,d_CLK_c_0,done_3175)
          | (d_a_internal,done_3198) := CostInput{__TC__#_real}(d_a,d_CLK_c_0,done_3187)
          | (d_x_internal,done_3209) := CostInput{__TC__#_real}(d_x,d_CLK_x_0,done_3215)
          | (d_err2_internal,done_2753) := CostInput{__TC__#_logical}(d_err2,d_CLK_err2_0,done_3209)
          | (d_C_cc_internal,done_3231) := CostInput{__TC__#_logical}(d_C_cc,d_CLK_c_0,done_3198)
          | (d_C_cc_391_internal,done_3242) := CostInput{__TC__#_logical}(d_C_cc_391,d_CLK_C_cc_391_0,done_3248)
          | (d_C_error_internal,done_3215) := CostInput{__TC__#_logical}(d_C_error,d_CLK_C_cc_391_0,done_3242)
          | (d_C_error_405_internal,done_3248) := CostInput{__TC__#_logical}(d_C_error_405,d_CLK_c_0,done_3231)
          | (d_error,done_3273) := CostOutput{__TC__#_logical}(d_error_internal,d_CLK_error_1,done_2841)
          | (d_x1,done_3283) := CostOutput{__TC__#_real}(d_x1_internal,d_CLK_x1_0,done_3289)
          | (d_x2,done_3289) := CostOutput{__TC__#_real}(d_x2_internal,d_CLK_x2_0,done_3273)
          | (d_OK,done_2418) := CostOutput{__TC__#_logical}(d_OK_internal,d_CLK_c_0,done_2489)
          | (d_stable,done_3181) := CostOutput{__TC__#_logical}(d_stable_internal,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_y,done_2606) := CostOutput{__TC__#_logical}(d_C_y_internal,d_CLK_stable_0,done_2277)
          | (d_C_x1,done_1336) := CostOutput{__TC__#_logical}(d_C_x1_internal,d_CLK_stable_0,done_2603)
          | (d_C_error_323,done_1262) := CostOutput{__TC__#_logical}(d_C_error_323_internal,d_CLK_c_0,done_2797)
          |)
       |)
      where 
      event CLK_749, CLK_744, CLK_740, CLK_738, CLK_657, CLK_652, CLK_644, CLK_583, CLK_567, CLK_222, CLK_220, CLK_217, CLK_215, CLK_213, CLK_211, CLK_209, CLK_207, CLK_error_0, CLK_x1_0, CLK_x21_0, CLK_XZX_181_0, CLK_x2_0, CLK_65, CLK_46, CLK_err2_0, 
           CLK_x_0, CLK_C_cc_391_0, CLK_24, CLK_x0_0, CLK_d_0, CLK_bb, CLK_c_0, CLK, CLK_stable_0;
      label nlabel_475, nlabel_476, nlabel_477, nlabel_479, nlabel_480, nlabel_483, nlabel_529; 
      label nlabel, nlabel_478, nlabel_481, nlabel_482, nlabel_484, nlabel_485, nlabel_486; 
      process Q1_Cluster_1_M =
           ( ? event CLK_217, CLK_error_0, CLK_46, CLK_err2_0, CLK_24, CLK_c_0;
               HomoType d_err2_internal, d_CLK_24, d_CLK_error_1, d_CLK_871;
             ! HomoType d_error_internal, done, XZX, done_1222, XZX_1233, done_1234, XZX_1244;
           )
         (| (| CLK_c_0 ^= done ^= done_1222 ^= done_1234
             | CLK_24 ^= d_CLK_24 ^= XZX_1244
             | CLK_err2_0 ^= d_err2_internal
             | CLK_46 ^= XZX ^= XZX_1233
             | CLK_error_0 ^= d_error_internal ^= d_CLK_error_1
             | CLK_217 ^= d_CLK_871
             |)
          | (XZX,done_1222) := CostWhen{__TC__#_logical}(d_err2_internal,d_CLK_871,NilHomoTypeValue when CLK_46)
          | XZX_1244 := CostConst{__TC__#_event}()
          | (XZX_1233,done_1234) := CostWhen{__TC__#_event}(XZX_1244,d_CLK_24,NilHomoTypeValue when CLK_46)
          | (d_error_internal,done) := CostDefault{__TC__#_logical}(XZX_1233,XZX,d_CLK_error_1,NilHomoTypeValue when CLK_46)
          |)
      %Q1_Cluster_1_M%; 
      process Q1_Cluster_5_M =
           ( ? event CLK_bb, CLK_c_0;
               HomoType d_b_internal, d_aa, d_CLK_bb;
             ! HomoType d_bb, d_XZX_99, done_2387, done_2396;
           )
         (| (| CLK_c_0 ^= d_b_internal ^= done_2387 ^= done_2396
             | CLK_bb ^= d_bb ^= d_aa ^= d_XZX_99 ^= d_CLK_bb
             |)
          | (d_bb,done_2387) := CostDivi{__TC__#_real,__TC__#_real}(d_XZX_99,d_aa,d_CLK_bb,done_2396)
          | (d_XZX_99,done_2396) := CostWhen{__TC__#_real}(d_b_internal,d_CLK_bb,NilHomoTypeValue when CLK_bb)
          |)
      %Q1_Cluster_5_M%; 
      process Q1_Cluster_8_M =
           ( ? event CLK_c_0;
               boolean C_error_438;
               HomoType d_C_error_405_internal, d_C_383, d_CLK_c_0;
             ! HomoType d_C_error_438, done_2629;
           )
         (| (| CLK_c_0 ^= C_error_438 ^= d_C_error_405_internal ^= d_C_383 ^= d_C_error_438 ^= d_CLK_c_0 ^= done_2629 |)
          | (d_C_error_438,done_2629) := CostOr(d_C_383,d_C_error_405_internal,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
          |)
      %Q1_Cluster_8_M%; 
      process Q1_Cluster_9_M =
           ( ? event CLK_bb, CLK_c_0;
               HomoType d_c_internal, d_aa, d_CLK_bb;
             ! HomoType d_XZX_103, d_cc, done_2659, done_2669;
           )
         (| (| CLK_c_0 ^= d_c_internal ^= done_2659 ^= done_2669
             | CLK_bb ^= d_aa ^= d_XZX_103 ^= d_cc ^= d_CLK_bb
             |)
          | (d_XZX_103,done_2659) := CostWhen{__TC__#_real}(d_c_internal,d_CLK_bb,NilHomoTypeValue when CLK_bb)
          | (d_cc,done_2669) := CostDivi{__TC__#_real,__TC__#_real}(d_XZX_103,d_aa,d_CLK_bb,done_2659)
          |)
      %Q1_Cluster_9_M%; 
      process Q1_Cluster_11_M =
           ( ? event CLK_C_cc_391_0, CLK_c_0;
               HomoType d_C_cc_internal, d_C_error_internal, d_CLK_c_0;
             ! HomoType d_C_error_283, done_2739;
           )
         (| (| CLK_c_0 ^= d_C_cc_internal ^= d_C_error_283 ^= d_CLK_c_0 ^= done_2739
             | CLK_C_cc_391_0 ^= d_C_error_internal
             |)
          | (d_C_error_283,done_2739) := CostLeftTT(d_C_error_internal,d_C_cc_internal,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
          |)
      %Q1_Cluster_11_M%; 
      process Q1_Cluster_12_M =
           ( ? event CLK_c_0;
               boolean C_error_323, C_391;
               HomoType d_C_380_262, d_C_error_283, d_CLK_c_0;
             ! HomoType d_C_error_323_internal, d_C_391, done_2769, done_2777, XZX_2783, done_2784;
           )
         (| (| CLK_c_0 ^= C_error_323 ^= C_391 ^= d_C_380_262 ^= d_C_error_283 ^= d_C_error_323_internal ^= d_C_391 ^= d_CLK_c_0 ^= done_2769 ^= done_2777 ^= XZX_2783 ^= done_2784 |)
          | (d_C_error_323_internal,done_2769) := CostOr(d_C_380_262,d_C_error_283,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
          | (XZX_2783,done_2784) := CostNot(d_C_380_262,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
          | (d_C_391,done_2777) := CostAnd(XZX_2783,d_C_error_283,d_CLK_c_0,done_2769)
          |)
      %Q1_Cluster_12_M%; 
      process Q1_Cluster_13_M =
           ( ? event CLK_c_0;
               boolean C_436, C_466;
               HomoType d_C_error_438, d_C_380_262, d_C_error_323_internal, d_C_391, d_CLK_c_0;
             ! HomoType d_C_433, d_C_436, d_C_466, done_2813, done_2821, done_2828;
           )
         (| (| CLK_c_0 ^= C_436 ^= C_466 ^= d_C_error_438 ^= d_C_380_262 ^= d_C_error_323_internal ^= d_C_391 ^= d_C_433 ^= d_C_436 ^= d_C_466 ^= d_CLK_c_0 ^= done_2813 ^= done_2821 ^= done_2828 |)
          | (d_C_433,done_2813) := CostOr(d_C_391,d_C_error_438,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
          | (d_C_436,done_2821) := CostOr(d_C_433,d_C_380_262,d_CLK_c_0,done_2813)
          | (d_C_466,done_2828) := CostAnd(d_C_error_323_internal,d_C_error_438,d_CLK_c_0,done_2821)
          |)
      %Q1_Cluster_13_M%; 
      process Q1_Cluster_2_M =
           ( ? event CLK_209, CLK_x1_0, CLK_x21_0, CLK_x_0, CLK_stable_0;
               HomoType d_x_internal, d_x21, d_CLK_x21_0, d_CLK_x1_0, d_CLK_863;
             ! HomoType d_x1_internal, done_1291, XZX_1301, done_1302, XZX_1313, done_1314;
           )
         (| (| CLK_stable_0 ^= done_1291 ^= done_1302 ^= done_1314
             | CLK_x_0 ^= d_x_internal
             | CLK_x21_0 ^= d_x21 ^= d_CLK_x21_0
             | CLK_x1_0 ^= d_x1_internal ^= d_CLK_x1_0 ^= XZX_1301 ^= XZX_1313
             | CLK_209 ^= d_CLK_863
             |)
          | (XZX_1301,done_1302) := CostWhen{__TC__#_real}(d_x_internal,d_CLK_863,NilHomoTypeValue when CLK_x1_0)
          | (XZX_1313,done_1314) := CostWhen{__TC__#_real}(d_x21,d_CLK_x21_0,NilHomoTypeValue when CLK_x1_0)
          | (d_x1_internal,done_1291) := CostDefault{__TC__#_real}(XZX_1313,XZX_1301,d_CLK_x1_0,NilHomoTypeValue when CLK_x1_0)
          |)
      %Q1_Cluster_2_M%; 
      process Q1_Cluster_3_M =
           ( ? event CLK_222, CLK_bb, CLK_c_0, CLK_stable_0;
               boolean biterate, C_y, C__429, C_x21, C_375, C_381, C_384, C_387, C_418, C_439, C_451, C_d, C_, C_380, C_335;
               HomoType d_OK_internal, d_stable_internal, d_bb, d_pre_next_yy, d_OK_354, d_cc, d_OK_238, d_CLK, d_CLK_c_0, d_CLK_bb, d_CLK_d_0, d_CLK_x0_0, d_CLK_65, d_CLK_x2_0, d_CLK_XZX_181_0, d_CLK_x21_0, d_CLK_stable_0, d_CLK_861, d_CLK_865, 
                        d_CLK_867, d_CLK_869, d_CLK_875;
             ! HomoType d_x2_internal, d_x21, d_x0, d_x_194, d_d, d_next_stable, d_yy, d_XZX_181, d_mx, d_next_yy, d_biterate, d_s, d_XZX_164, d_C, d_C_335, d_C_338, d_C_y_internal, d_C_d, d_C_d_364, d_C_, d_C__375, d_C__429, d_C_x21, d_C_469, d_C_476, 
                        d_C_380, d_C_383, d_dd, d_XZX_109, d_x_185, d_y, d_bb_127, d_C_d_247, d_C__256, d_C_380_262, d_C_356, d_C_371, d_C_375, d_C_381, d_C_384, d_C_387, d_C_409, d_C_412, d_C_415, d_C_418, d_C_439, d_C_451, done_1364, done_1370, 
                        done_1374, XZX_1382, done_1383, XZX_1394, done_1395, done_1406, done_1415, XZX_1418, XZX_1424, done_1425, done_1436, done_1442, XZX_1445, done_1446, XZX_1458, XZX_1464, done_1465, done_1481, done_1491, done_1500, done_1505, 
                        done_1511, XZX_1514, done_1515, XZX_1526, done_1527, XZX_1536, done_1537, XZX_1549, done_1558, XZX_1568, done_1569, done_1580, done_1586, XZX_1590, done_1591, done_1602, done_1608, XZX_1611, done_1612, XZX_1623, done_1624, XZX_1633,
                        done_1634, XZX_1646, XZX_1652, done_1653, XZX_1665, done_1666, done_1685, XZX_1693, done_1694, XZX_1703, done_1704, XZX_1713, done_1714, XZX_1723, done_1735, XZX_1738, done_1739, XZX_1748, done_1749, XZX_1761, done_1762, done_1773, 
                        done_1786, done_1792, XZX_1803, done_1810, XZX_1815, done_1816, XZX_1828, done_1836, done_1843, done_1852, XZX_1855, done_1862, done_1868, XZX_1871, done_1872, XZX_1881, XZX_1888, done_1889, done_1900, XZX_1911, done_1918, XZX_1926,
                        done_1927, XZX_1936, XZX_1943, done_1944, done_1955, done_1962, done_1969, XZX_1975, done_1976, done_1984, XZX_2000, done_2007, XZX_2025, done_2026, XZX_2039, XZX_2046, done_2047, done_2062, XZX_2079, done_2080, XZX_2092, XZX_2098, 
                        done_2099, done_2115, done_2125, done_2141, done_2154, done_2161, XZX_2173, done_2174, done_2182, XZX_2188, done_2189, done_2197, XZX_2203, done_2204, done_2212, XZX_2218, done_2219, done_2227, done_2240, done_2247;
           )
         (| (| CLK_stable_0 ^= biterate ^= C_y ^= C__429 ^= C_x21 ^= C_375 ^= C_381 ^= C_384 ^= C_387 ^= C_418 ^= C_439 ^= C_451 ^= C_335 ^= d_stable_internal ^= d_next_stable ^= d_yy ^= d_pre_next_yy ^= d_mx ^= d_next_yy ^= d_biterate ^= d_s ^= 
               d_XZX_164 ^= d_C ^= d_C_335 ^= d_C_338 ^= d_C_y_internal ^= d_OK_354 ^= d_C_d_364 ^= d_C__375 ^= d_C__429 ^= d_C_x21 ^= d_C_469 ^= d_C_476 ^= d_OK_238 ^= d_C_d_247 ^= d_C__256 ^= d_C_356 ^= d_C_371 ^= d_C_375 ^= d_C_381 ^= d_C_384 ^= 
               d_C_387 ^= d_C_409 ^= d_C_412 ^= d_C_415 ^= d_C_418 ^= d_C_439 ^= d_C_451 ^= d_CLK_stable_0 ^= done_1364 ^= done_1370 ^= done_1374 ^= done_1383 ^= done_1395 ^= done_1406 ^= done_1415 ^= done_1425 ^= done_1436 ^= done_1442 ^= done_1446 ^= 
               done_1465 ^= done_1481 ^= done_1491 ^= done_1500 ^= done_1505 ^= done_1511 ^= XZX_1514 ^= done_1515 ^= XZX_1526 ^= done_1527 ^= done_1537 ^= done_1558 ^= done_1569 ^= done_1580 ^= done_1586 ^= done_1591 ^= done_1602 ^= done_1608 ^= XZX_1611 
               ^= done_1612 ^= XZX_1623 ^= done_1624 ^= XZX_1633 ^= done_1634 ^= XZX_1646 ^= XZX_1652 ^= done_1653 ^= XZX_1665 ^= done_1666 ^= done_1685 ^= XZX_1693 ^= done_1694 ^= XZX_1703 ^= done_1704 ^= XZX_1713 ^= done_1714 ^= done_1735 ^= XZX_1738 ^= 
               done_1739 ^= XZX_1748 ^= done_1749 ^= XZX_1761 ^= done_1762 ^= done_1773 ^= done_1786 ^= done_1792 ^= XZX_1803 ^= done_1810 ^= XZX_1815 ^= done_1816 ^= XZX_1828 ^= done_1836 ^= done_1843 ^= done_1852 ^= done_1862 ^= done_1868 ^= XZX_1871 ^= 
               done_1872 ^= XZX_1888 ^= done_1889 ^= done_1900 ^= done_1918 ^= XZX_1926 ^= done_1927 ^= XZX_1943 ^= done_1944 ^= done_1955 ^= done_1962 ^= done_1969 ^= XZX_1975 ^= done_1976 ^= done_1984 ^= done_2007 ^= done_2026 ^= done_2047 ^= done_2062 
               ^= done_2080 ^= done_2099 ^= done_2115 ^= done_2125 ^= done_2141 ^= done_2154 ^= done_2161 ^= XZX_2173 ^= done_2174 ^= done_2182 ^= XZX_2188 ^= done_2189 ^= done_2197 ^= XZX_2203 ^= done_2204 ^= done_2212 ^= XZX_2218 ^= done_2219 ^= 
               done_2227 ^= done_2240 ^= done_2247
             | CLK ^= d_CLK
             | CLK_c_0 ^= d_OK_internal ^= d_C_383 ^= d_C_380_262 ^= d_CLK_c_0
             | CLK_bb ^= C_d ^= C_ ^= C_380 ^= d_bb ^= d_C_d ^= d_C_ ^= d_C_380 ^= d_dd ^= d_cc ^= d_CLK_bb ^= XZX_1568 ^= XZX_1855 ^= XZX_1911 ^= XZX_2000 ^= XZX_2025 ^= XZX_2039 ^= XZX_2046
             | CLK_d_0 ^= d_d ^= d_CLK_d_0 ^= XZX_1536 ^= XZX_1549 ^= XZX_1590 ^= XZX_1723
             | CLK_x0_0 ^= d_x0 ^= d_XZX_109 ^= d_CLK_x0_0 ^= XZX_1418 ^= XZX_1424
             | CLK_65 ^= d_CLK_65
             | CLK_x2_0 ^= d_x2_internal ^= d_x_194 ^= d_x_185 ^= d_y ^= d_bb_127 ^= d_CLK_x2_0 ^= XZX_1445 ^= XZX_1458 ^= XZX_1464 ^= XZX_2079 ^= XZX_2092 ^= XZX_2098
             | CLK_XZX_181_0 ^= d_XZX_181 ^= d_CLK_XZX_181_0
             | CLK_x21_0 ^= d_x21 ^= d_CLK_x21_0 ^= XZX_1382 ^= XZX_1394
             | CLK_207 ^= d_CLK_861
             | CLK_211 ^= d_CLK_865
             | CLK_213 ^= d_CLK_867
             | CLK_215 ^= d_CLK_869
             | CLK_222 ^= d_CLK_875 ^= XZX_1881 ^= XZX_1936
             |)
          | (d_x2_internal,done_1364) := CostRenaming{__TC__#_real}(d_x_185,d_CLK_x2_0,done_1370)
          | (XZX_1382,done_1383) := CostWhen{__TC__#_real}(d_x0,d_CLK_865,NilHomoTypeValue when CLK_x21_0)
          | (XZX_1394,done_1395) := CostWhen{__TC__#_real}(d_x_194,d_CLK_x2_0,NilHomoTypeValue when CLK_x21_0)
          | (d_x21,done_1374) := CostDefault{__TC__#_real}(XZX_1394,XZX_1382,d_CLK_x21_0,done_1364)
          | XZX_1418 := CostConst{__TC__#_real}()
          | (XZX_1424,done_1425) := CostUMinus{__TC__#_real}(d_XZX_109,d_CLK_x0_0,NilHomoTypeValue when CLK_x0_0)
          | (d_x0,done_1406) := CostDivi{__TC__#_real,__TC__#_real}(XZX_1424,XZX_1418,d_CLK_x0_0,done_1415)
          | XZX_1458 := CostConst{__TC__#_real}()
          | (XZX_1464,done_1465) := CostPlus{__TC__#_real,__TC__#_real}(d_bb_127,d_y,d_CLK_x2_0,NilHomoTypeValue when CLK_x2_0)
          | (XZX_1445,done_1446) := CostDivi{__TC__#_real,__TC__#_real}(XZX_1464,XZX_1458,d_CLK_x2_0,NilHomoTypeValue when CLK_x2_0)
          | (d_x_194,done_1436) := CostUMinus{__TC__#_real}(XZX_1445,d_CLK_x2_0,done_1442)
          | (d_d,done_1481) := CostWhen{__TC__#_real}(d_dd,d_CLK_d_0,NilHomoTypeValue when CLK_d_0)
          | (d_next_stable,done_1491) := CostLT{__TC__#_real,__TC__#_real}(d_s,d_epsilon,d_CLK_stable_0,done_1500)
          | (XZX_1514,done_1515) := CostWhen{__TC__#_real}(d_pre_next_yy,d_CLK_861,NilHomoTypeValue when CLK_stable_0)
          | XZX_1549 := CostConst{__TC__#_real}()
          | (XZX_1536,done_1537) := CostDivi{__TC__#_real,__TC__#_real}(d_d,XZX_1549,d_CLK_d_0,NilHomoTypeValue when CLK_d_0)
          | (XZX_1526,done_1527) := CostWhen{__TC__#_real}(XZX_1536,d_CLK_d_0,NilHomoTypeValue when CLK_stable_0)
          | (d_yy,done_1505) := CostDefault{__TC__#_real}(XZX_1526,XZX_1514,d_CLK_stable_0,done_1511)
          | (XZX_1568,done_1569) := CostWhen{__TC__#_real}(d_bb,d_CLK_bb,NilHomoTypeValue when CLK_bb)
          | (d_XZX_181,done_1558) := CostCell{__TC__#_real}(XZX_1568,d_CLK_XZX_181_0,d_CLK_XZX_181_0,NilHomoTypeValue when CLK_XZX_181_0)
          | (XZX_1590,done_1591) := CostWhen{__TC__#_real}(d_d,d_CLK_d_0,NilHomoTypeValue when CLK_d_0)
          | (d_mx,done_1580) := CostCell{__TC__#_real}(XZX_1590,d_CLK_stable_0,d_CLK_stable_0,done_1586)
          | (XZX_1611,done_1612) := CostWhen{__TC__#_real}(d_yy,d_CLK_869,NilHomoTypeValue when CLK_stable_0)
          | XZX_1646 := CostConst{__TC__#_real}()
          | (XZX_1665,done_1666) := CostDivi{__TC__#_real,__TC__#_real}(d_mx,d_yy,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (XZX_1652,done_1653) := CostPlus{__TC__#_real,__TC__#_real}(d_yy,XZX_1665,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (XZX_1633,done_1634) := CostDivi{__TC__#_real,__TC__#_real}(XZX_1652,XZX_1646,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (XZX_1623,done_1624) := CostWhen{__TC__#_real}(XZX_1633,d_CLK,NilHomoTypeValue when CLK_stable_0)
          | (d_next_yy,done_1602) := CostDefault{__TC__#_real}(XZX_1623,XZX_1611,d_CLK_stable_0,done_1608)
          | (XZX_1703,done_1704) := CostNot(d_stable_internal,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (XZX_1693,done_1694) := CostWhen{__TC__#_logical}(XZX_1703,d_CLK_861,NilHomoTypeValue when CLK_stable_0)
          | XZX_1723 := CostConst{__TC__#_event}()
          | (XZX_1713,done_1714) := CostWhen{__TC__#_event}(XZX_1723,d_CLK_d_0,NilHomoTypeValue when CLK_stable_0)
          | (d_biterate,done_1685) := CostDefault{__TC__#_logical}(XZX_1713,XZX_1693,d_CLK_stable_0,done_1505)
          | (XZX_1748,done_1749) := CostUMinus{__TC__#_real}(d_XZX_164,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (XZX_1738,done_1739) := CostWhen{__TC__#_real}(XZX_1748,d_CLK_867,NilHomoTypeValue when CLK_stable_0)
          | (XZX_1761,done_1762) := CostWhen{__TC__#_real}(d_XZX_164,d_CLK_65,NilHomoTypeValue when CLK_stable_0)
          | (d_s,done_1500) := CostDefault{__TC__#_real}(XZX_1761,XZX_1738,d_CLK_stable_0,done_1735)
          | (d_XZX_164,done_1773) := CostMinus{__TC__#_real,__TC__#_real}(d_next_yy,d_yy,d_CLK_stable_0,done_1602)
          | (d_C,done_1786) := CostNot(d_biterate,d_CLK_stable_0,done_1685)
          | XZX_1803 := CostConst{__TC__#_real}()
          | (d_C_335,done_1792) := CostGEQ{__TC__#_real,__TC__#_real}(d_XZX_164,XZX_1803,d_CLK_stable_0,done_1773)
          | XZX_1828 := CostConst{__TC__#_real}()
          | (XZX_1815,done_1816) := CostGEQ{__TC__#_real,__TC__#_real}(d_XZX_164,XZX_1828,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_338,done_1810) := CostNot(XZX_1815,d_CLK_stable_0,done_1792)
          | (d_C_y_internal,done_1836) := CostAnd(d_next_stable,d_biterate,d_CLK_stable_0,done_1491)
          | XZX_1855 := CostConst{__TC__#_real}()
          | (d_C_d,done_1843) := CostGT{__TC__#_real,__TC__#_real}(d_dd,XZX_1855,d_CLK_bb,done_1852)
          | XZX_1881 := CostConst{__TC__#_logical}()
          | (XZX_1871,done_1872) := CostWhen{__TC__#_logical}(XZX_1881,d_CLK_875,NilHomoTypeValue when CLK_stable_0)
          | (XZX_1888,done_1889) := CostWhen{__TC__#_logical}(d_C_d,d_CLK_bb,NilHomoTypeValue when CLK_stable_0)
          | (d_C_d_364,done_1862) := CostDefault{__TC__#_logical}(XZX_1888,XZX_1871,d_CLK_stable_0,done_1868)
          | XZX_1911 := CostConst{__TC__#_real}()
          | (d_C_,done_1900) := CostEQ{__TC__#_real,__TC__#_real}(d_dd,XZX_1911,d_CLK_bb,done_1843)
          | XZX_1936 := CostConst{__TC__#_logical}()
          | (XZX_1926,done_1927) := CostWhen{__TC__#_logical}(XZX_1936,d_CLK_875,NilHomoTypeValue when CLK_stable_0)
          | (XZX_1943,done_1944) := CostWhen{__TC__#_logical}(d_C_,d_CLK_bb,NilHomoTypeValue when CLK_stable_0)
          | (d_C__375,done_1918) := CostDefault{__TC__#_logical}(XZX_1943,XZX_1926,d_CLK_stable_0,done_1862)
          | (d_C__429,done_1955) := CostOr(d_C_y_internal,d_OK_354,d_CLK_stable_0,done_1836)
          | (d_C_x21,done_1962) := CostOr(d_C_y_internal,d_C__375,d_CLK_stable_0,done_1955)
          | (XZX_1975,done_1976) := CostNot(d_C_y_internal,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_469,done_1969) := CostAnd(XZX_1975,d_C__375,d_CLK_stable_0,done_1962)
          | (d_C_476,done_1984) := CostNot(d_C_d_364,d_CLK_stable_0,done_1918)
          | XZX_2000 := CostConst{__TC__#_real}()
          | (d_C_380,done_1415) := CostLT{__TC__#_real,__TC__#_real}(d_dd,XZX_2000,d_CLK_bb,done_1900)
          | (d_C_383,done_2007) := CostLeftTT(d_C_380,d_OK_internal,d_CLK_c_0,done_1406)
          | XZX_2039 := CostConst{__TC__#_real}()
          | (XZX_2025,done_2026) := CostMult{__TC__#_real,__TC__#_real}(XZX_2039,d_cc,d_CLK_bb,NilHomoTypeValue when CLK_bb)
          | (XZX_2046,done_2047) := CostMult{__TC__#_real,__TC__#_real}(d_bb,d_bb,d_CLK_bb,NilHomoTypeValue when CLK_bb)
          | (d_dd,done_1852) := CostMinus{__TC__#_real,__TC__#_real}(XZX_2046,XZX_2025,d_CLK_bb,NilHomoTypeValue when CLK_bb)
          | (d_XZX_109,done_2062) := CostWhen{__TC__#_real}(d_bb,d_CLK_x0_0,NilHomoTypeValue when CLK_x0_0)
          | XZX_2092 := CostConst{__TC__#_real}()
          | (XZX_2098,done_2099) := CostMinus{__TC__#_real,__TC__#_real}(d_bb_127,d_y,d_CLK_x2_0,NilHomoTypeValue when CLK_x2_0)
          | (XZX_2079,done_2080) := CostDivi{__TC__#_real,__TC__#_real}(XZX_2098,XZX_2092,d_CLK_x2_0,NilHomoTypeValue when CLK_x2_0)
          | (d_x_185,done_1370) := CostUMinus{__TC__#_real}(XZX_2079,d_CLK_x2_0,done_1436)
          | (d_y,done_2115) := CostWhen{__TC__#_real}(d_yy,d_CLK_x2_0,NilHomoTypeValue when CLK_x2_0)
          | (d_bb_127,done_2125) := CostWhen{__TC__#_real}(d_XZX_181,d_CLK_x2_0,NilHomoTypeValue when CLK_x2_0)
          | (d_C_d_247,done_1586) := CostLeftTT(d_C_d,d_stable_internal,d_CLK_stable_0,done_1984)
          | (d_C__256,done_2141) := CostLeftTT(d_C_,d_stable_internal,d_CLK_stable_0,done_1580)
          | (d_C_380_262,done_1868) := CostLeftTT(d_C_380,d_OK_internal,d_CLK_c_0,done_2007)
          | (d_C_356,done_2154) := CostAnd(d_C_469,d_C__256,d_CLK_stable_0,done_1969)
          | (d_C_371,done_2161) := CostOr(d_C_476,d_C_d_247,d_CLK_stable_0,done_2141)
          | (XZX_2173,done_2174) := CostNot(d_C_d_247,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_375,done_1511) := CostAnd(XZX_2173,d_C_476,d_CLK_stable_0,done_2161)
          | (XZX_2188,done_2189) := CostNot(d_C_y_internal,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_381,done_2182) := CostAnd(XZX_2188,d_C_356,d_CLK_stable_0,done_2154)
          | (XZX_2203,done_2204) := CostNot(d_C_335,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_384,done_2197) := CostAnd(XZX_2203,d_C_338,d_CLK_stable_0,done_1810)
          | (XZX_2218,done_2219) := CostNot(d_biterate,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_387,done_2212) := CostAnd(XZX_2218,d_C,d_CLK_stable_0,done_1786)
          | (d_C_409,done_2227) := CostOr(d_C_371,d_biterate,d_CLK_stable_0,done_2212)
          | (d_C_412,done_1608) := CostOr(d_C_409,d_C_387,d_CLK_stable_0,done_2227)
          | (d_C_415,done_2240) := CostOr(d_C_412,d_C_335,d_CLK_stable_0,done_2197)
          | (d_C_418,done_2247) := CostOr(d_C_415,d_C_384,d_CLK_stable_0,done_2240)
          | (d_C_439,done_1735) := CostOr(d_C_418,d_OK_238,d_CLK_stable_0,done_2247)
          | (d_C_451,done_1442) := CostAnd(d_stable_internal,d_C_y_internal,d_CLK_stable_0,done_2182)
          |)
      %Q1_Cluster_3_M%; 
      process Q1_Cluster_4_M =
           ( ? event CLK_c_0, CLK_stable_0;
               boolean C_397, OK;
               HomoType d_a_internal, d_stable_internal, d_CLK_c_0, d_CLK_bb, d_CLK_stable_0;
             ! HomoType d_OK_internal, d_OK_354, d_aa, d_OK_238, d_C_397, done_2320, XZX_2332, done_2339, done_2346, done_2356, done_2363;
           )
         (| (| CLK_stable_0 ^= C_397 ^= d_stable_internal ^= d_OK_354 ^= d_OK_238 ^= d_C_397 ^= d_CLK_stable_0 ^= done_2320 ^= done_2339 ^= done_2346 ^= done_2356 ^= done_2363
             | CLK_c_0 ^= OK ^= d_a_internal ^= d_OK_internal ^= d_CLK_c_0 ^= XZX_2332
             | CLK_bb ^= d_aa ^= d_CLK_bb
             |)
          | XZX_2332 := CostConst{__TC__#_real}()
          | (d_OK_internal,done_2320) := CostNEQ{__TC__#_real,__TC__#_real}(d_a_internal,XZX_2332,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
          | (d_OK_354,done_2339) := CostLeftTT(d_OK_internal,d_stable_internal,d_CLK_stable_0,done_2320)
          | (d_aa,done_2346) := CostWhen{__TC__#_real}(d_a_internal,d_CLK_bb,NilHomoTypeValue when CLK_bb)
          | (d_OK_238,done_2356) := CostLeftTT(d_OK_internal,d_stable_internal,d_CLK_stable_0,done_2339)
          | (d_C_397,done_2363) := CostNot(d_OK_238,d_CLK_stable_0,done_2356)
          |)
      %Q1_Cluster_4_M%; 
      process Q1_Cluster_6_M =
           ( ? event CLK_220, CLK_C_cc_391_0, CLK_stable_0;
               HomoType d_C_cc_391_internal, d_stable_internal, d_CLK_C_cc_391_0, d_CLK_stable_0, d_CLK_873;
             ! HomoType d_C_cc_397, d_C_cc_391_277, done_2439, XZX_2448, done_2449, XZX_2458, XZX_2465, done_2466, done_2477;
           )
         (| (| CLK_stable_0 ^= d_stable_internal ^= d_C_cc_397 ^= d_C_cc_391_277 ^= d_CLK_stable_0 ^= done_2439 ^= XZX_2448 ^= done_2449 ^= XZX_2465 ^= done_2466 ^= done_2477
             | CLK_C_cc_391_0 ^= d_C_cc_391_internal ^= d_CLK_C_cc_391_0
             | CLK_220 ^= d_CLK_873 ^= XZX_2458
             |)
          | XZX_2458 := CostConst{__TC__#_logical}()
          | (XZX_2448,done_2449) := CostWhen{__TC__#_logical}(XZX_2458,d_CLK_873,NilHomoTypeValue when CLK_stable_0)
          | (XZX_2465,done_2466) := CostWhen{__TC__#_logical}(d_C_cc_391_internal,d_CLK_C_cc_391_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_cc_397,done_2439) := CostDefault{__TC__#_logical}(XZX_2465,XZX_2448,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_cc_391_277,done_2477) := CostLeftTT(d_C_cc_391_internal,d_stable_internal,d_CLK_stable_0,done_2439)
          |)
      %Q1_Cluster_6_M%; 
      process Q1_Cluster_7_M =
           ( ? event CLK_stable_0;
               boolean C_x1, C_378, C_430, C_445, C_454, C_460;
               HomoType d_stable_internal, d_C_cc_397, d_C_x21, d_C_cc_268, d_C_cc_391_277, d_CLK_stable_0;
             ! HomoType d_C_x1_internal, d_C_473, d_C_365, d_C_378, d_C_427, d_C_430, d_C_445, d_C_454, d_C_460, done_2512, done_2520, XZX_2526, done_2527, done_2535, done_2542, XZX_2548, done_2549, done_2557, done_2564, done_2572, done_2580, done_2588;
           )
         (| (| CLK_stable_0 ^= C_x1 ^= C_378 ^= C_430 ^= C_445 ^= C_454 ^= C_460 ^= d_stable_internal ^= d_C_cc_397 ^= d_C_x21 ^= d_C_x1_internal ^= d_C_473 ^= d_C_cc_268 ^= d_C_cc_391_277 ^= d_C_365 ^= d_C_378 ^= d_C_427 ^= d_C_430 ^= d_C_445 ^= 
               d_C_454 ^= d_C_460 ^= d_CLK_stable_0 ^= done_2512 ^= done_2520 ^= XZX_2526 ^= done_2527 ^= done_2535 ^= done_2542 ^= XZX_2548 ^= done_2549 ^= done_2557 ^= done_2564 ^= done_2572 ^= done_2580 ^= done_2588 |)
          | (d_C_x1_internal,done_2512) := CostOr(d_C_x21,d_C_cc_397,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (XZX_2526,done_2527) := CostNot(d_C_x21,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_473,done_2520) := CostAnd(XZX_2526,d_C_cc_397,d_CLK_stable_0,done_2512)
          | (d_C_365,done_2535) := CostAnd(d_C_473,d_C_cc_391_277,d_CLK_stable_0,done_2520)
          | (XZX_2548,done_2549) := CostNot(d_C_x21,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_378,done_2542) := CostAnd(XZX_2548,d_C_365,d_CLK_stable_0,done_2535)
          | (d_C_427,done_2557) := CostOr(d_C_x21,d_C_x1_internal,d_CLK_stable_0,done_2542)
          | (d_C_430,done_2564) := CostOr(d_C_427,d_C_378,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_445,done_2572) := CostOr(d_C_378,d_C_x1_internal,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_454,done_2580) := CostAnd(d_C_x1_internal,d_C_cc_268,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_460,done_2588) := CostAnd(d_stable_internal,d_C_x1_internal,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          |)
      %Q1_Cluster_7_M%; 
      process Q1_Cluster_10_M =
           ( ? event CLK_c_0, CLK_stable_0;
               boolean C_394;
               HomoType d_C_cc_internal, d_stable_internal, d_CLK_stable_0;
             ! HomoType d_C_cc_268, d_C_394, done_2708, done_2716;
           )
         (| (| CLK_stable_0 ^= C_394 ^= d_stable_internal ^= d_C_cc_268 ^= d_C_394 ^= d_CLK_stable_0 ^= done_2708 ^= done_2716
             | CLK_c_0 ^= d_C_cc_internal
             |)
          | (d_C_cc_268,done_2708) := CostLeftTT(d_C_cc_internal,d_stable_internal,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_C_394,done_2716) := CostNot(d_C_cc_268,d_CLK_stable_0,done_2708)
          |)
      %Q1_Cluster_10_M%; 
      process Q1_Cluster_delays_M =
           ( ? event CLK_stable_0;
               HomoType d_next_stable, d_next_yy, d_CLK_stable_0;
             ! HomoType d_stable_internal, d_pre_next_yy, done_2868, done_2879;
           )
         (| (| CLK_stable_0 ^= d_stable_internal ^= d_next_stable ^= d_pre_next_yy ^= d_next_yy ^= d_CLK_stable_0 ^= done_2868 ^= done_2879 |)
          | (d_stable_internal,done_2868) := CostDelay{__TC__#_logical}(d_next_stable,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          | (d_pre_next_yy,done_2879) := CostDelay{__TC__#_real}(d_next_yy,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
          |)
      %Q1_Cluster_delays_M%; 
      boolean biterate, C, C_y, OK_354, C_d_364, C__375, C_cc_397, C__429, C_x21, C_x1, C_469, C_473, C_476, C_383, C_error_438, OK_238, C_d_247, C__256, C_380_262, C_cc_268, C_cc_391_277, C_error_283, C_error_323, C_356, C_365, C_371, C_375, C_378, C_381,
             C_384, C_387, C_391, C_394, C_397, C_409, C_412, C_415, C_418, C_427, C_430, C_433, C_436, C_439, C_445, C_451, C_454, C_460, C_466;
      HomoType d_c_internal, d_b_internal, d_a_internal, d_x_internal, d_err2_internal, d_C_cc_internal, d_C_cc_391_internal, d_C_error_internal, d_C_error_405_internal, d_error_internal, d_x1_internal, d_x2_internal, d_OK_internal, d_stable_internal, 
               d_x21, d_x0, d_x_194, d_d, d_bb, d_next_stable, d_yy, d_XZX_181, d_pre_next_yy, d_mx, d_next_yy, d_biterate, d_s, d_XZX_164, d_C, d_C_335, d_C_338, d_C_y_internal, d_OK_354, d_C_d, d_C_d_364, d_C_, d_C__375, d_C_cc_397, d_C__429, d_C_x21, 
               d_C_x1_internal, d_C_469, d_C_473, d_C_476, d_C_380, d_C_383, d_C_error_438, d_dd, d_aa, d_XZX_99, d_XZX_103, d_cc, d_XZX_109, d_x_185, d_y, d_bb_127, d_OK_238, d_C_d_247, d_C__256, d_C_380_262, d_C_cc_268, d_C_cc_391_277, d_C_error_283, 
               d_C_error_323_internal, d_C_356, d_C_365, d_C_371, d_C_375, d_C_378, d_C_381, d_C_384, d_C_387, d_C_391, d_C_394, d_C_397, d_C_409, d_C_412, d_C_415, d_C_418, d_C_427, d_C_430, d_C_433, d_C_436, d_C_439, d_C_445, d_C_451, d_C_454, d_C_460, 
               d_C_466, d_nlabel, d_nlabel_475, d_nlabel_476, d_nlabel_477, d_nlabel_478, d_nlabel_479, d_nlabel_480, d_nlabel_481, d_nlabel_482, d_nlabel_483, d_nlabel_484, d_nlabel_485, d_nlabel_486, d_CLK, d_CLK_c_0, d_CLK_bb, d_CLK_d_0, d_CLK_x0_0, 
               d_CLK_24, d_CLK_C_cc_391_0, d_CLK_x_0, d_CLK_err2_0, d_CLK_65, d_CLK_x2_0, d_CLK_XZX_181_0, d_CLK_x21_0, d_CLK_x1_0, d_CLK_stable_0, d_CLK_error_1, d_CLK_861, d_CLK_863, d_CLK_865, d_CLK_867, d_CLK_869, d_CLK_871, d_CLK_873, d_CLK_875, 
               done, XZX, done_1222, XZX_1233, done_1234, XZX_1244, done_1259, done_1262, done_1266, done_1270, done_1274, done_1278, done_1282, done_1291, XZX_1301, done_1302, XZX_1313, done_1314, done_1333, done_1336, done_1340, done_1344, done_1348, 
               done_1352, done_1356, done_1364, done_1370, done_1374, XZX_1382, done_1383, XZX_1394, done_1395, done_1406, done_1415, XZX_1418, XZX_1424, done_1425, done_1436, done_1442, XZX_1445, done_1446, XZX_1458, XZX_1464, done_1465, done_1481, 
               done_1491, done_1500, done_1505, done_1511, XZX_1514, done_1515, XZX_1526, done_1527, XZX_1536, done_1537, XZX_1549, done_1558, XZX_1568, done_1569, done_1580, done_1586, XZX_1590, done_1591, done_1602, done_1608, XZX_1611, done_1612, 
               XZX_1623, done_1624, XZX_1633, done_1634, XZX_1646, XZX_1652, done_1653, XZX_1665, done_1666, done_1685, XZX_1693, done_1694, XZX_1703, done_1704, XZX_1713, done_1714, XZX_1723, done_1735, XZX_1738, done_1739, XZX_1748, done_1749, XZX_1761, 
               done_1762, done_1773, done_1786, done_1792, XZX_1803, done_1810, XZX_1815, done_1816, XZX_1828, done_1836, done_1843, done_1852, XZX_1855, done_1862, done_1868, XZX_1871, done_1872, XZX_1881, XZX_1888, done_1889, done_1900, XZX_1911, 
               done_1918, XZX_1926, done_1927, XZX_1936, XZX_1943, done_1944, done_1955, done_1962, done_1969, XZX_1975, done_1976, done_1984, XZX_2000, done_2007, XZX_2025, done_2026, XZX_2039, XZX_2046, done_2047, done_2062, XZX_2079, done_2080, 
               XZX_2092, XZX_2098, done_2099, done_2115, done_2125, done_2141, done_2154, done_2161, XZX_2173, done_2174, done_2182, XZX_2188, done_2189, done_2197, XZX_2203, done_2204, done_2212, XZX_2218, done_2219, done_2227, done_2240, done_2247, 
               done_2277, done_2280, done_2283, done_2288, done_2292, done_2296, done_2300, done_2304, done_2308, done_2312, done_2320, XZX_2332, done_2339, done_2346, done_2356, done_2363, done_2373, done_2376, done_2380, done_2387, done_2396, done_2415, 
               done_2418, done_2423, done_2427, done_2431, done_2439, XZX_2448, done_2449, XZX_2458, XZX_2465, done_2466, done_2477, done_2489, done_2492, done_2497, done_2501, done_2505, done_2512, done_2520, XZX_2526, done_2527, done_2535, done_2542, 
               XZX_2548, done_2549, done_2557, done_2564, done_2572, done_2580, done_2588, done_2603, done_2606, done_2610, done_2614, done_2618, done_2622, done_2629, done_2641, done_2648, done_2652, done_2659, done_2669, done_2693, done_2697, done_2701, 
               done_2708, done_2716, done_2731, done_2739, done_2753, done_2758, done_2762, done_2769, done_2777, XZX_2783, done_2784, done_2797, done_2803, done_2807, done_2813, done_2821, done_2828, done_2841, done_2848, done_2852, done_2856, done_2860, 
               done_2868, done_2879, done_2906, done_2914, done_2922, done_2930, done_2938, done_2946, done_2954, done_2962, done_2970, done_2986, done_2994, done_3002, done_3010, done_3018, done_3030, done_3038, done_3046, done_3054, done_3062, done_3070,
               done_3078, done_3086, done_3094, done_3175, done_3181, done_3187, done_3198, done_3209, done_3215, done_3231, done_3242, done_3248, done_3273, done_3283, done_3289;
      end
   %Q1_COST%; %(| done_2900 := pack(d_next_yy,d_next_stable)
                | (d_nlabel_529,done_2893) := CostSubGraph(done_2900,d_stable_internal,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
                | (d_CLK_46,done_2978) := CostWhen1(d_C_error_438,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
                | (d_CLK_889,done_3102) := CostWhen1(d_C_418,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
                | (d_CLK_897,done_3110) := CostWhen1(d_C_430,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
                | (d_CLK_901,done_3118) := CostWhen1(d_C_436,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
                | (d_CLK_903,done_3126) := CostWhen1(d_C_439,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
                | (d_CLK_907,done_3134) := CostWhen1(d_C_445,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
                | (d_CLK_911,done_3142) := CostWhen1(d_C_451,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
                | (d_CLK_913,done_3150) := CostWhen1(d_C_454,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
                | (d_CLK_917,done_3158) := CostWhen1(d_C_460,d_CLK_stable_0,NilHomoTypeValue when CLK_stable_0)
                | (d_CLK_921,done_3166) := CostWhen1(d_C_466,d_CLK_c_0,NilHomoTypeValue when CLK_c_0)
                |)***war: unused signals 
   *
   %
   use Cost_Context, STD, COSTBIB; 
end %M_Q1_COST%; 
